// the file NK.c was renamed to BuildSettings.h
// as of 05-07-03 it will now have my misc functions.
// moved these here from Console.c, they help in debug/testing.

// this block allows you to regain control of pchar after a delay. Useful in testing AI funcs on pchar,
// and then getting control back to reset the situation.
// call it with postevent("resetpchar_event", msec); where msec is the delay in ms.
#event_handler("resetpchar_event", "resetpchar");
void resetpchar()
{
	LAi_SetPlayerType(GetMainCharacter());
}

// creates an officer for the player, of type otype, model (from array!!!) model, offset-to-level offset, of nation, and points/perks left assignable if(blank)
ref CreateOfficer_Cheat(string otype, string model, int offset, int nation, bool blank)
{
	ref pchar = GetMainCharacter();
	ref ch;
	ch = GetCharacter(FindFreeRandomOfficer());
	ch.dialog.filename = "enc_officer_dialog.c";
	ch.offgen = true;
	ch.officer = true;
	ch.Dialog.CurrentNode = "hired";
	ch.Dialog.TempNode = "hired";
	ch.quest.meeting = "1";
	ch.quest = "True";
	ch.reputation = 65;
	ch.nation = nation;
	ch.AbordageMode = 0;
	LAi_SetLoginTime(ch, 0.0, 24.0); // KK
	LAi_group_MoveCharacter(ch, LAI_GROUP_PLAYER); // KK

	ch.quest.officertype = otype;
	LAi_Create_Officer(offset, &ch);
	SetModelfromArray(&ch, GetModelIndex(model));
	LAi_NPC_Equip(&ch, sti(ch.rank), true, true);
	SetRandomNameToCharacter(&ch);
	DeleteAttribute(ch, "greeting");
	if(blank) ResetChar_Cheat(&ch);
	if(FindLoadedLocation() != -1) PlaceCharacter(&ch, "goto", pchar.location);
	AddPassenger(&pchar, &ch, false);
	return &ch;
}

// resets all skills/perks to allow custom assignment
void ResetChar_Cheat(ref ch)
{
	ch.skill.Leadership = 1;
	ch.skill.Fencing = 1;
	ch.skill.Sailing = 1;
	ch.skill.Accuracy = 1;
	ch.skill.Cannons = 1;
	ch.skill.Grappling = 1;
	ch.skill.Repair = 1;
	ch.skill.Defence = 1;
	ch.skill.Commerce = 1;
	ch.skill.Sneak = 1;

	ch.skill.freeskill = sti(ch.rank) * 2;
	DeleteAttribute(ch,"perks");
	ch.perks.freepoints = sti(ch.rank);
	ResetHP(&ch); // 05-07-03 use new func
	/*if(sti(ch.index) == GetMainCharacterIndex())
	{
		LAi_SetHP(&ch, LAI_DEFAULT_HP + sti(ch.rank) * 5, LAI_DEFAULT_HP + sti(ch.rank) * 5);
	}
	else { LAi_SetHP(&ch, LAI_DEFAULT_HP + sti(ch.rank) * makeint(11-GetDifficulty()), LAI_DEFAULT_HP + sti(ch.rank) * makeint(11-GetDifficulty())); }*/
}

// creates ship of id shipname, speed srate, turn trate, and max gun caliber cal. Gives long guns of that caliber, and full crew.
void CreateShip_Cheat(string shipname, int nat, float srate, float trate, int cal)
{
	ref pchar = GetMainCharacter();
	pchar.ship.type = shipname;
	int iShipType = GetCharacterShipType(pchar); // KK
	aref arship; makearef(arship, pchar.ship); DeleteAttribute(arship,"stats");
	SetRandomStatsToShip(GetMainCharacterIndex(), iShipType, nat); // KK
	arship.stats.maxcaliber = cal; arship.stats.speedrate = srate; arship.stats.turnrate = trate; arship.cannons.type = GetCannonByTypeAndCaliber("long gun", cal);
	SetCrewQuantity(&pchar, GetMaxCrewQuantity(&pchar));
// KK -->
	if (FindLoadedLocation() >= 0 && locNumShips > 0) {
		DeleteRiggingEnvironment();
		LocLoadShips(&Locations[FindLoadedLocation()]);
	}
// <-- KK
}

// repairs all damage--HP and SP, fixes masts, and removes blots. Masts do not appear until reload sea.
// also resets crew qty and sets morale at max, and sets balls at 700.
void RepairShip_Cheat()
{
	ref pchar = GetMainCharacter();
	ResetCannons(pchar);
	DeleteAttribute(&pchar,"ship.masts");
	pchar.ship.hp = GetCharacterShipHP(pchar) / 9.5;
	pchar.ship.sp = 0.5;
	SetCrewQuantity(&pchar, GetMaxCrewQuantity(&pchar));
	pchar.ship.crew.morale = MORALE_MAX;
	pchar.seatime.basecrewmorale = MORALE_MAX;
	pchar.seatime.tempmorale = MORALE_MAX;
	ProcessSailRepair(&pchar,100.0);
	ProcessHullRepair(&pchar, 100.0);
	SetCharacterGoods(&pchar, GOOD_BALLS, 700);
}

// sets wind to 30kts
void Wind_Cheat()
{
	Weather.Wind.Speed = 30.0;
	fWeatherSpeed = 30.0;
}

// sets up lvl12 characters with skills, perks, and items as I like. Allows types "player", qm, nav, can, and capnavy.
void SetUpChar_Cheat(ref ch, string otype)
{
	string stmp;

	switch(otype)
	{
		case "player":
			ch.skill.freeskill = 0;
			ch.skill.leadership = 8;
			ch.skill.fencing = 9;
			ch.skill.sailing = 4;
			ch.skill.accuracy = 1;
			ch.skill.cannons = 1;
			ch.skill.grappling = 1;
			ch.skill.repair = 1;
			ch.skill.defence = 1;
			ch.skill.commerce = 1;
			ch.skill.sneak = 7;
			ch.items.bladex4 = 1;
			ch.items.blade1 = 1;
			ch.items.potion1 = 22;
			ch.items.pistol1 = 1;
			ch.items.spyglass1 = 1;
			ch.items.commonarmor = 1;
			stmp = "blade19+2";
			ch.items.(stmp) = 1;
			stmp = "pistol8+2";
			ch.items.(stmp) = 1;
			ch.items.spyglass4 = 1;
			ch.items.jewelry2 = 1;
			ch.items.jewelry3 = 1;
			ch.items.jewelry4 = 1;
			ch.items.jewelry10 = 1;
			ch.items.indian5 = 1;
			ch.items.mineral16 = 2;
			ch.items.jewelry8 = 1;
			ch.items.jewelry9 = 1;
			ch.items.indian7 = 1;
			ch.items.mineral3 = 2;
			ch.items.potion2 = 3;
			ch.items.potion3 = 5;
			ch.items.potionrum = 2;
			ch.perks.freepoints = 0;
			ch.perks.list = "";
			ch.perks.list.basicdefense = 1;
			ch.perks.list.advanceddefense = 1;
			ch.perks.list.criticalhit = 1;
			ch.perks.list.swordplayprofessional = 1;
			ch.perks.list.gunman = 1;
			ch.perks.list.sharedexperience = 1;
			ch.perks.list.ironwill = 1;
			ch.perks.list.shipspeedup = 1;
			ch.perks.list.shipturnrateup = 1;
			ch.perks.list.stormprofessional = 1;
			ch.perks.list.turn180 = 1;
			ch.perks.list.sandbankmaneuver = 1;
		break;

		case OFFIC_TYPE_NAVIGATOR:
			ch.skill.freeskill = 0;
			ch.skill.leadership = 1;
			ch.skill.fencing = 7;
			ch.skill.sailing = 7;
			ch.skill.accuracy = 1;
			ch.skill.cannons = 1;
			ch.skill.grappling = 1;
			ch.skill.repair = 1;
			ch.skill.defence = 9;
			ch.skill.commerce = 1;
			ch.skill.sneak = 5;
			ch.items.commonarmor = 1;
			stmp = "blade19+2";
			ch.items.(stmp) = 1;
			stmp = "pistol8+2";
			ch.items.(stmp) = 1;
			ch.items.jewelry3 = 1;
			ch.items.jewelry4 = 1;
			ch.items.indian5 = 1;
			ch.items.mineral3 = 2;
			ch.items.mineral16 = 2;
			ch.items.jewelry8 = 1;
			ch.items.jewelry9 = 1;
			ch.items.indian7 = 1;
			ch.perks.freepoints = 0;
			ch.perks.list = "";
			ch.perks.list.shipspeedup = 1;
			ch.perks.list.shipturnrateup = 1;
			ch.perks.list.stormprofessional = 1;
			ch.perks.list.turn180 = 1;
			ch.perks.list.sandbankmaneuver = 1;
			ch.perks.list.sailingprofessional = 1;
			ch.perks.list.basicdefense = 1;
			ch.perks.list.advanceddefense = 1;
			ch.perks.list.criticalhit = 1;
			ch.perks.list.swordplayprofessional = 1;
			ch.perks.list.gunman = 1;
			ch.perks.list.sharedexperience = 1;
		break;

		case OFFIC_TYPE_QMASTER:
			ch.skill.freeskill = 0;
			ch.skill.leadership = 1;
			ch.skill.fencing = 1;
			ch.skill.sailing = 1;
			ch.skill.accuracy = 1;
			ch.skill.cannons = 1;
			ch.skill.grappling = 8;
			ch.skill.repair = 9;
			ch.skill.defence = 2;
			ch.skill.commerce = 9;
			ch.skill.sneak = 1;
			ch.items.commonarmor = 1;
			stmp = "blade19+2";
			ch.items.(stmp) = 1;
			//stmp = "pistol8+2";
			//ch.items.(stmp) = 1;
			ch.items.jewelry3 = 1;
			ch.items.jewelry8 = 1;
			ch.items.jewelry10 = 1;
			ch.items.indian7 = 1;
			ch.items.mineral3 = 2;
			ch.items.mineral7 = 1;
			ch.items.mineral8 = 1;
			ch.items.jewelry9 = 1;
			ch.perks.freepoints = 0;
			ch.perks.list = "";
			ch.perks.list.longrangegrappling = 1;
			ch.perks.list.grapplingprofessional = 1;
			ch.perks.list.basicbattlestate = 1;
			ch.perks.list.advancedbattlestate = 1;
			ch.perks.list.shipdefenseprofessional = 1;
			ch.perks.list.lightrepair = 1;
			ch.perks.list.instantrepair = 1;
			ch.perks.list.trustworthy = 1;
			ch.perks.list.basiccommerce = 1;
			ch.perks.list.advancedcommerce = 1;
			ch.perks.list.basiclandowner = 1;
			ch.perks.list.sharedexperience = 1;
		break;

		case OFFIC_TYPE_CANNONEER:
			ch.skill.freeskill = 0;
			ch.skill.leadership = 1;
			ch.skill.fencing = 7;
			ch.skill.sailing = 1;
			ch.skill.accuracy = 9;
			ch.skill.cannons = 8;
			ch.skill.grappling = 1;
			ch.skill.repair = 1;
			ch.skill.defence = 1;
			ch.skill.commerce = 1;
			ch.skill.sneak = 4;
			ch.items.commonarmor = 1;
			stmp = "blade19+2";
			ch.items.(stmp) = 1;
			stmp = "pistol8+2";
			ch.items.(stmp) = 1;
			ch.items.jewelry3 = 1;
			ch.items.jewelry8 = 1;
			ch.items.jewelry9 = 1;
			ch.items.indian7 = 1;
			ch.items.mineral1 = 3;
			ch.items.mineral15 = 1;
			ch.items.chinatiger = 1;
			ch.perks.freepoints = 0;
			ch.perks.list = "";
			ch.perks.list.fastreload = 1;
			ch.perks.list.hulldamageup = 1;
			ch.perks.list.sailsdamageup = 1;
			ch.perks.list.crewdamageup = 1;
			ch.perks.list.criticalshoot = 1;
			ch.perks.list.longrangeshoot = 1;
			ch.perks.list.cannonprofessional = 1;
			ch.perks.list.basicdefense = 1;
			ch.perks.list.advanceddefense = 1;
			ch.perks.list.criticalhit = 1;
			ch.perks.list.swordplayprofessional = 1;
			ch.perks.list.gunman = 1;
		break;

		case OFFIC_TYPE_CAPNAVY:
			ch.skill.freeskill = 0;
			ch.skill.leadership = 5;
			ch.skill.fencing = 1;
			ch.skill.sailing = 7;
			ch.skill.accuracy = 5;
			ch.skill.cannons = 3;
			ch.skill.grappling = 1;
			ch.skill.repair = 1;
			ch.skill.defence = 9;
			ch.skill.commerce = 1;
			ch.skill.sneak = 1;
			ch.items.commonarmor = 1;
			stmp = "blade19+2";
			ch.items.(stmp) = 1;
			stmp = "pistol8+2";
			ch.items.(stmp) = 1;
			ch.items.jewelry2 = 1;
			ch.items.jewelry3 = 1;
			ch.items.jewelry4 = 1;
			ch.items.jewelry10 = 1;
			ch.items.indian5 = 1;
			ch.items.mineral1 = 3;
			ch.items.mineral7 = 1;
			ch.items.mineral8 = 1;
			ch.items.mineral15 = 1;
			ch.items.mineral16 = 2;
			ch.items.chinatiger = 1;
			ch.items.mineral3 = 2;
			ch.perks.freepoints = 0;
			ch.perks.list = "";
			ch.perks.list.basicbattlestate = 1;
			ch.perks.list.advancedbattlestate = 1;
			ch.perks.list.shipdefenseprofessional = 1;
			ch.perks.list.lightrepair = 1;
			ch.perks.list.stormprofessional = 1;
			ch.perks.list.sharedexperience = 1;
			ch.perks.list.ironwill = 1;
			ch.perks.list.hulldamageup = 1;
			ch.perks.list.sailsdamageup = 1;
			ch.perks.list.crewdamageup = 1;
			ch.perks.list.criticalshoot = 1;
			ch.perks.list.fastreload = 1;
		break;
	}
	for(int s = 0; s < 10; s++)
	{
		DeleteAttribute(&ch, "skill." + GetSkillName(s) + ".mod");
		GetCharacterSkill(&ch, GetSkillName(s)); // NK/GZ items mod to force refresh of modifiers.
	}
}

bool ReloadToLocModel(string model)
{
	string locid = "";
	ref loc;
	for(int i = 0; i < nLocationsNum; i++)
	{
		loc = &Locations[i];
		if(!CheckAttribute(loc, "models.always.locators")) continue;
		if(loc.models.always.locators == model)
		{
			locid = loc.id;
			break;
		}
	}
	if(locid != "") return DoQuestReloadToLocation(locid, "reload", loc.reload.l1.name, "");
	else return false;
}

// ----------------
// PB FUNCTIONS -->
// ----------------

string GetAttribute(ref tmp, string att)
{
	if(CheckAttribute(tmp,att)) return tmp.(att);
	return "-1";//MAXIMUS: and now we can use it for int and float check
}

void GiveModel2Player(string model, bool assign)
{
	Characters[GetMainCharacterIndex()].clothes.(model) = true;
	if(assign) SetModelfromArray(GetMainCharacter(), GetModelIndex(model));
}

void GiveShip2Character(ref char, string shiptype, string shipname, int cannon_type, int nat, bool hirecrew, bool getsupplies)
{
// KK -->
	if(shiptype != SHIP_CURSED) // PB
	{
		int ship_type = GetShipIndex(shiptype);
		if (ship_type < 0 || ship_type == SHIP_NOTUSED) return;
		if (ship_type >= SHIP_TYPES_QUANTITY && shiptype != "Boat") return;
	}
// <-- KK
	char.ship.type = shiptype;
	char.ship.name = shipname;
	aref arship; makearef(arship, char.ship);
	DeleteAttribute(arship,"stats");
// KK -->
	SetRandomStatsToShip(sti(char.index), GetCharacterShipType(char), nat);
	ref rShip = GetShipByType(GetCharacterShipType(char));
	if (cannon_type != CANNON_TYPE_NONECANNON) {
		ResetCannons(char);
		if (cannon_type < 0 || cannon_type >= CANNON_TYPES_QUANTITY) cannon_type = sti(rShip.Cannon);
		int max_caliber = sti(rShip.MaxCaliber);
		int cannon_model = GetCannonType(cannon_type);
		if (sti(GetAttribute(Cannon[cannon_type],"caliber")) > max_caliber) {
			string sCannonType = "long gun";
			if (cannon_model == CANNON_NAME_CARRONADE) sCannonType = "carronade";
			cannon_type = GetCannonByTypeAndCaliber(sCannonType, max_caliber);
		}
		char.Ship.Cannons.Type = cannon_type;
	} else {
		SetNoneCannonsOnShip(char);
	}
// <-- KK
	DeleteAttribute(&char,"ship.masts");
// LDH -->
	char.ship.sp = GetCharacterShipSP(char);
	if(CheckAttribute(char,"ship.sails"))
	{
		int temp = sti(char.ship.sails);
		DeleteAttribute(char,"ship.sails");
		char.ship.sails = temp;
	}
	char.ship.hp = GetCharacterShipHP(char);
	// this doen't do anything on sea or dock, only on land away from sea
	DeleteBlots(char,GetBlotsQuantity(char));
// <-- LDH
	if(hirecrew || sti(GetCrewQuantity(&char)) > sti(GetMaxCrewQuantity(&char)))
	{
		SetCrewQuantity(&char, GetMaxCrewQuantity(&char));
	}
	for (int i = 0; i < GOODS_QUANTITY; i++) AddCharacterGoods(char, i, 0); // KK
	if(getsupplies || sti(GetCargoLoad(&char)) > sti(GetCargoMaxSpace(&char)))
	{
		EmptyShip(char) // First remove all goods from the ship
		SupplyShip(char) // Then add them again
	}
// KK -->
	if (FindLoadedLocation() >= 0 && locNumShips > 0) {
		DeleteRiggingEnvironment();
		LocLoadShips(&Locations[FindLoadedLocation()]);
	}
// <-- KK
}

void EmptyShip(ref char)
{
	for(int i=0;i<GOODS_QUANTITY;i++) RemoveCharacterGoods(char,i,GetCargoGoods(char,i));
}

void SupplyShip(ref char)
{
	if(FOOD_ON) AddCharacterGoods(char, GOOD_WHEAT, 1+makeint(makefloat(GetCrewQuantity(&char)) * FOOD_PER_CREW * WHEAT_DAYS));
	if(FOOD_ON) AddCharacterGoods(char, GOOD_RUM, 1+makeint(makefloat(GetCrewQuantity(&char)) * FOOD_PER_CREW * RUM_DAYS));
	if(CANNONPOWDER_MOD && GetMaxCannonQuantity(&char) > 0)
	{
		int needPwdr = 0;
		float averageQty = 0.0;
		ref rCannon; makeref(rCannon,Cannon[GetCaracterShipCannonsType(char)]);
		if (USE_REAL_CANNONS) 	{ averageQty = makefloat(GetCargoGoods(&char,GOOD_BALLS) + GetCargoGoods(&char,GOOD_GRAPES) + GetCargoGoods(&char,GOOD_KNIPPELS))/3; }
		else 					{ averageQty = makefloat(GetCargoGoods(&char,GOOD_BALLS) + GetCargoGoods(&char,GOOD_GRAPES) + GetCargoGoods(&char,GOOD_KNIPPELS) + GetCargoGoods(&char,GOOD_BOMBS))/4; }
		float canCharge = makefloat(averageQty/makefloat(GetMaxCannonQuantity(&char)));
		if(CheckAttribute(rCannon,"gunpowder")) needPwdr = sti(rCannon.gunpowder);
		AddCharacterGoods(char, GOOD_GUNPOWDER, makeint((makefloat(GetMaxCannonQuantity(&char)) * needPwdr * canCharge) + (makefloat(GetCrewQuantity(&char)) * 3)));
	}
	AddCharacterGoods(char, GOOD_BALLS, makeint(makefloat(GetMaxCannonQuantity(&char)) * BALLS_PER));
	AddCharacterGoods(char, GOOD_GRAPES, makeint(makefloat(GetMaxCannonQuantity(&char)) * GRAPE_PER));
	AddCharacterGoods(char, GOOD_KNIPPELS, makeint(makefloat(GetMaxCannonQuantity(&char)) * CHAIN_PER));
	if(!USE_REAL_CANNONS) AddCharacterGoods(char, GOOD_BOMBS, makeint(makefloat(GetMaxCannonQuantity(&char)) * BOMBS_PER));
	AddCharacterGoods(char, GOOD_SAILCLOTH, makeint(makefloat(GetCharacterShipHP(&char)) * SAIL_PER));
	AddCharacterGoods(char, GOOD_PLANKS, makeint(makefloat(GetCharacterShipHP(&char)) * PLANKS_PER));
}

void CreatePortLandscape(string sPortLandscape)
{
	ref PChar = GetMainCharacter();
	ref deck = &Locations[FindLocation(GetCharacterShipQDeck(PChar))];
// KK -->
	int i = 0;
	int j = 0;
	int inum = 0;
	int jnum = 0;
	int locidx = FindLocation(sPortLandscape);
	if (locidx < 0) return;
	if (!CheckAttribute(&Locations[locidx], "models.always.l1")) return;
	if (CheckAttribute(deck, "models.always.port1")) DeleteAttribute(deck,"models.always.port1");
	if (CheckAttribute(deck, "models.always.port2")) DeleteAttribute(deck,"models.always.port2");
	aref arLandscapes = GetFiles("RESOURCE\MODELS\" + Locations[locidx].filespath.models, "*_landscape.gm");
	inum = GetAttributesNum(arLandscapes);
	for (i = 0; i < inum; i++) {
		string gmfile = GetAttributeValue(GetAttributeN(arLandscapes, i));
		gmfile = strcut(gmfile, 0, strlen(gmfile) - 4);
		string sLandscape = Locations[locidx].filespath.models + "\" + gmfile;
		string port = "port" + (i + 1);
		deck.models.always.(port) = "..\..\..\" + sLandscape;
	}
	string island = Locations[locidx].island;
	ref rIsland = GetIslandByID(island);
	if (CheckAttribute(deck, "locators.ships_other")) DeleteAttribute(deck, "locators.ships_other");
	deck.locators.ships_other = "";
	aref dships; makearef(dships, deck.locators.ships_other);
	aref arIslandReload; makearef(arIslandReload, rIsland.reload);
	int num = GetAttributesNum(arIslandReload);
	for (i = 0; i < num; i++) {
		aref curReload = GetAttributeN(arIslandReload, i);
		if (curReload.go == sPortLandscape) {
			aref iships; makearef(iships, curReload.ships);
			jnum = GetAttributesNum(iships);
			for (j = 0; j < jnum; j++) {
				aref ariship = GetAttributeN(iships, j);
				string l = GetAttributeName(ariship);
				dships.(l) = "";
				aref ardship; makearef(ardship, dships.(l));
				CopyAttributes(ardship, ariship);
			}
		}
	}
// <-- KK
}

// KK -->
void DeletePortLandscape()
{
	ref PChar = GetMainCharacter();
	ref deck = &Locations[FindLocation(GetCharacterShipQDeck(PChar))];
	if (CheckAttribute(deck, "models.always.port1")) DeleteAttribute(deck,"models.always.port1");
	if (CheckAttribute(deck, "models.always.port2")) DeleteAttribute(deck,"models.always.port2");
}

string IsPortLandscapeEnabled(string sLocation)
{
	int locidx = FindLocation(sLocation);
	if (locidx < 0) return "";
	int llocidx = FindLoadedLocation();
	if (llocidx > 0 && HasSubStr(Locations[llocidx].id, "ShipDeck") == false) return "";
	if (!bCanEnterToLand) return "";
	if (!CheckAttribute(&Locations[locidx], "filespath.models") || !CheckAttribute(&Locations[locidx], "models.always.l1")) return "";
	if (FindFile("RESOURCE\MODELS\\" + Locations[locidx].filespath.models, "*_landscape.gm", Locations[locidx].models.always.l1 + "_landscape.gm") != "") return sLocation;
	return "";
}
// <-- KK

void GivePromotionReward()
{
	ref pchar = GetMainCharacter();
	ref ch;
	string qual = "";
	if (ENABLE_WEAPONSMOD) qual = "+2";
	switch(GetCurrentLocationNation())
	{
		case ENGLAND:
			switch(GetRank(pchar, GetCurrentLocationNation()))
			{
				case 1: // Midshipman
					if(pchar.sex != "woman")
					{
						switch(GetAttribute(pchar,"model"))
						{
							case "cnorrington": GiveModel2Player("Mdnorrington", true); break;
							case "blaze": GiveModel2Player("47_Blaze_brtmds", true); break;
							switch(rand(3))
							{
								case 0: GiveModel2Player("brtmds1_18", true); break;
								case 1: GiveModel2Player("brtmds2_18", true); break;
								case 2: GiveModel2Player("brtmds3_18", true); break;
								case 3: GiveModel2Player("brtmds4_18", true); break;
							}
						}
					}
					Characters[GetCharacterIndex("Crewmember_01")].model = Nations[ENGLAND].fantomModel.m1;
					Characters[GetCharacterIndex("Crewmember_01")].headmodel = "h_"+Nations[ENGLAND].fantomModel.m1;
					Characters[GetCharacterIndex("Crewmember_02")].model = Nations[ENGLAND].fantomModel.m2;
					Characters[GetCharacterIndex("Crewmember_02")].headmodel = "h_"+Nations[ENGLAND].fantomModel.m2;
					Characters[GetCharacterIndex("Crewmember_03")].model = Nations[ENGLAND].fantomModel.m3;
					Characters[GetCharacterIndex("Crewmember_03")].headmodel = "h_"+Nations[ENGLAND].fantomModel.m3;
					Characters[GetCharacterIndex("Crewmember_04")].model = Nations[ENGLAND].fantomModel.m4;
					Characters[GetCharacterIndex("Crewmember_04")].headmodel = "h_"+Nations[ENGLAND].fantomModel.m4;
					Characters[GetCharacterIndex("Crewmember_05")].model = Nations[ENGLAND].fantomModel.m5;
					Characters[GetCharacterIndex("Crewmember_05")].headmodel = "h_"+Nations[ENGLAND].fantomModel.m5;
                    Characters[GetCharacterIndex("Treas_Crewmember_1")].model = Nations[ENGLAND].fantomModel.m1;
					Characters[GetCharacterIndex("Treas_Crewmember_1")].headmodel = "h_"+Nations[ENGLAND].fantomModel.m1;
					Characters[GetCharacterIndex("Treas_Crewmember_2")].model = Nations[ENGLAND].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_2")].headmodel = "h_"+Nations[ENGLAND].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_3")].model = Nations[ENGLAND].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_3")].headmodel = "h_"+Nations[ENGLAND].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_4")].model = Nations[ENGLAND].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_4")].headmodel = "h_"+Nations[ENGLAND].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_5")].model = Nations[ENGLAND].fantomModel.m5;
                    Characters[GetCharacterIndex("Treas_Crewmember_5")].headmodel = "h_"+Nations[ENGLAND].fantomModel.m5;
					Characters[GetCharacterIndex("Treas_Crewmember_6")].model = Nations[ENGLAND].fantomModel.m6;
					Characters[GetCharacterIndex("Treas_Crewmember_6")].headmodel = "h_"+Nations[ENGLAND].fantomModel.m6;
					Characters[GetCharacterIndex("Treas_Crewmember_7")].model = Nations[ENGLAND].fantomModel.m6;
                    Characters[GetCharacterIndex("Treas_Crewmember_7")].headmodel = "h_"+Nations[ENGLAND].fantomModel.m6;
                    Characters[GetCharacterIndex("Treas_Crewmember_8")].model = Nations[ENGLAND].fantomModel.m5;
                    Characters[GetCharacterIndex("Treas_Crewmember_8")].headmodel = "h_"+Nations[ENGLAND].fantomModel.m5;
                    Characters[GetCharacterIndex("Treas_Crewmember_9")].model = Nations[ENGLAND].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_9")].headmodel = "h_"+Nations[ENGLAND].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_10")].model = Nations[ENGLAND].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_10")].headmodel = "h_"+Nations[ENGLAND].fantomModel.m3;
					pchar.boardingmodels = "ENGLAND";
				break;
				case 2: // 3rd Lieutenant

					if(pchar.sex != "woman")
					{
						switch(GetAttribute(pchar,"model"))
						{
							case "depp":  GiveModel2Player("47_Ltsparrow", true); break;
							case "jack":  GiveModel2Player("47_Ltsparrow", true); break;
							case "Mdnorrington":  GiveModel2Player("Ltnorrington", true); break;
							case "47_Blaze_brtmds":	GiveModel2Player("47_Blaze_brtlt", true); break;
							switch(rand(2))
							{
								case 0: GiveModel2Player("brtlut1_18", true); break;
								case 1: GiveModel2Player("brtlut2_18", true); break;
								case 2: GiveModel2Player("brtlut3_18", true); break;
							}
						}
					}
					GiveItem2Character(pchar,"blade24"+qual); // English Officer's Saber
					EquipCharacterByItem(pchar,"blade24"+qual);
				break;
				case 3: // 2nd Lieutenant
				break;
				case 4: // 1st Lieutenant
				break;
				case 5: // Commander
				break;
				case 6: // Captain
					if(PROMOTION_SHIPS)
					{
						ch = CreateOfficer_Cheat(OFFIC_TYPE_FIRSTMATE, "9JdEng_A3", 3, ENGLAND, false);
						ExchangeCharacterShip(ch, pchar);
						SetCompanionIndex(pchar, -1, GetCharacterIndex(ch.id)));
						switch(GetCurrentPeriod())
						{
							case PERIOD_EARLY_EXPLORERS:
								GiveShip2Character(pchar, "RN_RevengeW", "Revenge", -1, ENGLAND, true, false);
							break;

							case PERIOD_THE_SPANISH_MAIN:
								GiveShip2Character(pchar, "RN_Poseidon", "Poseidon", -1, ENGLAND, true, false);
							break;

							case PERIOD_GOLDEN_AGE_OF_PIRACY:
								GiveShip2Character(pchar, "HMS_Mordaunt", "HMS Mordaunt", -1, ENGLAND, true, false);
							break;

							case PERIOD_COLONIAL_POWERS:
								GiveShip2Character(pchar, "HMS_Surprise", "HMS Surprise", -1, ENGLAND, true, false);
							break;

							case PERIOD_REVOLUTIONS:
								GiveShip2Character(pchar, "HMS_Bellona", "HMS Bellona", -1, ENGLAND, true, false);
							break;

							case PERIOD_NAPOLEONIC:
								GiveShip2Character(pchar, "HMS_Victory", "HMS Victory", -1, ENGLAND, true, false);
							break;
						}
					}
					if(pchar.sex != "woman")
					{
						switch(GetAttribute(pchar,"model"))
						{
							case "47_Ltsparrow":		GiveModel2Player("47_Cptsparrow", true); break;
							case "Ltnorrington":		GiveModel2Player("Cpnorrington", true); break;
							case "47_Blaze_brtlt":		GiveModel2Player("47_Blaze_brtcpt", true); break;
							switch(rand(1))
							{
								case 0: GiveModel2Player("brtcpt1_18", true); break;
								case 1: GiveModel2Player("brtcpt2_18", true); break;
							}
						}
					}
				break;
				case 7: // Commodore
					if(pchar.sex != "woman")
					{
						switch(GetAttribute(pchar,"model"))
						{
							case "47_Cptsparrow":		GiveModel2Player("47_Cosparrow", true); break;
							case "Cpnorrington":		GiveModel2Player("Conorrington", true); break;
							case "47_Blaze_brtcpt":		GiveModel2Player("47_Blaze_brtco", true); break;
							GiveModel2Player("brtbath_18", true);
						}
					}
					GiveItem2Character(pchar,"blade22"+qual); // Corsair's Pride
					EquipCharacterByItem(pchar,"blade22"+qual);
				break;
				case 8: // Rear Admiral
				break;
				case 9: // Vice Admiral
				break;
				case 10: // Admiral
					if(pchar.sex != "woman")
					{
						switch(GetAttribute(pchar,"model"))
						{
							case "47_Cosparrow":		GiveModel2Player("47_Admsparrow", true); break;
							case "47_Blaze_brtco":		GiveModel2Player("47_Blaze_brtadm", true); break;
							case "Conorrington":		GiveModel2Player("Conorrington", true); break;
							switch(rand(1))
							{
								case 0: GiveModel2Player("brtadm1_18", true); break;
								case 1: GiveModel2Player("brtadm2_18", true); break;
							}
						}
					}
				break;
				case 11: // Admiral of the Fleet
				break;
				case 12: // First Lord of the Admiralty
				break;
			}
		break;
		case HOLLAND:
			switch(GetRank(pchar, GetCurrentLocationNation()))
			{
				case 1: // Cadet Officier
					Characters[GetCharacterIndex("Crewmember_01")].model = Nations[HOLLAND].fantomModel.m1;
					Characters[GetCharacterIndex("Crewmember_01")].headmodel = "h_"+Nations[HOLLAND].fantomModel.m1;
					Characters[GetCharacterIndex("Crewmember_02")].model = Nations[HOLLAND].fantomModel.m2;
					Characters[GetCharacterIndex("Crewmember_02")].headmodel = "h_"+Nations[HOLLAND].fantomModel.m2;
					Characters[GetCharacterIndex("Crewmember_03")].model = Nations[HOLLAND].fantomModel.m3;
					Characters[GetCharacterIndex("Crewmember_03")].headmodel = "h_"+Nations[HOLLAND].fantomModel.m3;
					Characters[GetCharacterIndex("Crewmember_04")].model = Nations[HOLLAND].fantomModel.m4;
					Characters[GetCharacterIndex("Crewmember_04")].headmodel = "h_"+Nations[HOLLAND].fantomModel.m4;
					Characters[GetCharacterIndex("Crewmember_05")].model = Nations[HOLLAND].fantomModel.m5;
					Characters[GetCharacterIndex("Crewmember_05")].headmodel = "h_"+Nations[HOLLAND].fantomModel.m5;
					Characters[GetCharacterIndex("Treas_Crewmember_1")].model = Nations[HOLLAND].fantomModel.m1;
					Characters[GetCharacterIndex("Treas_Crewmember_1")].headmodel = "h_"+Nations[HOLLAND].fantomModel.m1;
					Characters[GetCharacterIndex("Treas_Crewmember_2")].model = Nations[HOLLAND].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_2")].headmodel = "h_"+Nations[HOLLAND].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_3")].model = Nations[HOLLAND].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_3")].headmodel = "h_"+Nations[HOLLAND].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_4")].model = Nations[HOLLAND].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_4")].headmodel = "h_"+Nations[HOLLAND].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_5")].model = Nations[HOLLAND].fantomModel.m5;
                    Characters[GetCharacterIndex("Treas_Crewmember_5")].headmodel = "h_"+Nations[HOLLAND].fantomModel.m5;
					Characters[GetCharacterIndex("Treas_Crewmember_6")].model = Nations[HOLLAND].fantomModel.m6;
					Characters[GetCharacterIndex("Treas_Crewmember_6")].headmodel = "h_"+Nations[HOLLAND].fantomModel.m6;
					Characters[GetCharacterIndex("Treas_Crewmember_7")].model = Nations[HOLLAND].fantomModel.m5;
                    Characters[GetCharacterIndex("Treas_Crewmember_7")].headmodel = "h_"+Nations[HOLLAND].fantomModel.m5;
                    Characters[GetCharacterIndex("Treas_Crewmember_8")].model = Nations[HOLLAND].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_8")].headmodel = "h_"+Nations[HOLLAND].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_9")].model = Nations[HOLLAND].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_9")].headmodel = "h_"+Nations[HOLLAND].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_10")].model = Nations[HOLLAND].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_10")].headmodel = "h_"+Nations[HOLLAND].fantomModel.m2;
					pchar.boardingmodels = "DUTCH";
				break;
				case 2: // 3e Luitenant
					GiveItem2Character(pchar,"blade23"+qual); // Dutch Admiralty Sword
					EquipCharacterByItem(pchar,"blade23"+qual);
				break;
				case 3: // 2e Luitenant
				break;
				case 4: // 1e Luitenant
				break;
				case 5: // Schout-bij-Nacht
					if(PROMOTION_SHIPS)
					{
						ch = CreateOfficer_Cheat(OFFIC_TYPE_FIRSTMATE, "9JdHol_A3", 3, HOLLAND, false);
						ExchangeCharacterShip(ch, pchar);
						SetCompanionIndex(pchar, -1, GetCharacterIndex(ch.id)));
						switch(GetCurrentPeriod())
						{
							case PERIOD_EARLY_EXPLORERS:
								GiveShip2Character(pchar, "NL_Fleut50", "Batavia", -1, HOLLAND, true, false);
							break;

							case PERIOD_THE_SPANISH_MAIN:
								GiveShip2Character(pchar, "NL_SevenProvincien", "Zeven Provincien", -1, HOLLAND, true, false);
							break;

							case PERIOD_GOLDEN_AGE_OF_PIRACY:
								GiveShip2Character(pchar, "NL_ConvoiShip", "Wapen van Hoorn", -1, HOLLAND, true, false);
							break;

							case PERIOD_COLONIAL_POWERS:
								GiveShip2Character(pchar, "NL_Lineship", "Vergulde Draeck", -1, HOLLAND, true, false);
							break;

							case PERIOD_REVOLUTIONS:
								GiveShip2Character(pchar, "NL_PinnaceofWar47", "Halve Maen", -1, HOLLAND, true, false);
							break;

							case PERIOD_NAPOLEONIC:
								GiveShip2Character(pchar, "NL_Amsterdam", "Amsterdam", -1, HOLLAND, true, false);
							break;
						}
					}
				break;
				case 6: // Kapitein-Luitenant
				break;
				case 7: // Kapitein ter zee
				break;
				case 8: // Commandeur
					GiveItem2Character(pchar,"blade26"+qual); // Solingen Rapier
					EquipCharacterByItem(pchar,"blade26"+qual);
				break;
				case 9: // Vice-Admiraal
				break;
				case 10: // Luitenant-Admiraal
				break;
				case 11: // Admiraal
				break;
				case 12: // Generaal-Admiraal
				break;
			}
		break;
		case FRANCE:
			switch(GetRank(pchar, GetCurrentLocationNation()))
			{
				case 1: // Enseigne
					if(pchar.sex != "woman")
					{
						if(pchar.model == "blaze")							GiveModel2Player("47_Blaze_france", true);
						if(pchar.model == "depp" || pchar.model == "jack")	GiveModel2Player("47_Sparrow_france", true);
					}
					Characters[GetCharacterIndex("Crewmember_01")].model = Nations[FRANCE].fantomModel.m1;
					Characters[GetCharacterIndex("Crewmember_01")].headmodel = "h_"+Nations[FRANCE].fantomModel.m1;
					Characters[GetCharacterIndex("Crewmember_02")].model = Nations[FRANCE].fantomModel.m2;
					Characters[GetCharacterIndex("Crewmember_02")].headmodel = "h_"+Nations[FRANCE].fantomModel.m2;
					Characters[GetCharacterIndex("Crewmember_03")].model = Nations[FRANCE].fantomModel.m3;
					Characters[GetCharacterIndex("Crewmember_03")].headmodel = "h_"+Nations[FRANCE].fantomModel.m3;
					Characters[GetCharacterIndex("Crewmember_04")].model = Nations[FRANCE].fantomModel.m4;
					Characters[GetCharacterIndex("Crewmember_04")].headmodel = "h_"+Nations[FRANCE].fantomModel.m4;
					Characters[GetCharacterIndex("Crewmember_05")].model = Nations[FRANCE].fantomModel.m5;
					Characters[GetCharacterIndex("Crewmember_05")].headmodel = "h_"+Nations[FRANCE].fantomModel.m5;
					Characters[GetCharacterIndex("Treas_Crewmember_1")].model = Nations[FRANCE].fantomModel.m1;
					Characters[GetCharacterIndex("Treas_Crewmember_1")].headmodel = "h_"+Nations[FRANCE].fantomModel.m1;
					Characters[GetCharacterIndex("Treas_Crewmember_2")].model = Nations[FRANCE].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_2")].headmodel = "h_"+Nations[FRANCE].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_3")].model = Nations[FRANCE].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_3")].headmodel = "h_"+Nations[FRANCE].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_4")].model = Nations[FRANCE].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_4")].headmodel = "h_"+Nations[FRANCE].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_5")].model = Nations[FRANCE].fantomModel.m5;
                    Characters[GetCharacterIndex("Treas_Crewmember_5")].headmodel = "h_"+Nations[FRANCE].fantomModel.m5;
					Characters[GetCharacterIndex("Treas_Crewmember_6")].model = Nations[FRANCE].fantomModel.m6;
					Characters[GetCharacterIndex("Treas_Crewmember_6")].headmodel = "h_"+Nations[FRANCE].fantomModel.m6;
					Characters[GetCharacterIndex("Treas_Crewmember_7")].model = Nations[FRANCE].fantomModel.m1;
                    Characters[GetCharacterIndex("Treas_Crewmember_7")].headmodel = "h_"+Nations[FRANCE].fantomModel.m1;
                    Characters[GetCharacterIndex("Treas_Crewmember_8")].model = Nations[FRANCE].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_8")].headmodel = "h_"+Nations[FRANCE].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_9")].model = Nations[FRANCE].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_9")].headmodel = "h_"+Nations[FRANCE].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_10")].model = Nations[FRANCE].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_10")].headmodel = "h_"+Nations[FRANCE].fantomModel.m4;
					pchar.boardingmodels = "FRANCE";
				break;
				case 2: // Sous-Lieutenant de Vaisseau
					if(pchar.sex != "woman")
					{
						switch(rand(2))
						{
							case 0: GiveModel2Player("fra_lut_18", true); break;
							case 1: GiveModel2Player("fra_lut2_18", true); break;
							case 2: GiveModel2Player("fra_lut3_18", true); break;
						}
					}
					GiveItem2Character(pchar,"blade9"+qual); // French Admiralty Rapier
					EquipCharacterByItem(pchar,"blade9"+qual);
				break;
				case 3: // Lieutenant de Vaisseau
				break;
				case 4: // Capitaine de Corvette
				break;
				case 5: // Capitaine de Fregate
					if(PROMOTION_SHIPS)
					{
						ch = CreateOfficer_Cheat(OFFIC_TYPE_FIRSTMATE, "9JdFra_A3", 3, FRANCE, false);
						ExchangeCharacterShip(ch, pchar);
						SetCompanionIndex(pchar, -1, GetCharacterIndex(ch.id)));
						switch(GetCurrentPeriod())
						{
							case PERIOD_EARLY_EXPLORERS:
								GiveShip2Character(pchar, "FR_Couronne", "La Couronne", -1, FRANCE, true, false);
							break;

							case PERIOD_THE_SPANISH_MAIN:
								GiveShip2Character(pchar, "FR_Licorne", "La Licorne", -1, FRANCE, true, false);
							break;

							case PERIOD_GOLDEN_AGE_OF_PIRACY:
								GiveShip2Character(pchar, "FR_SuperiorWarship", "Le Conqurant", -1, FRANCE, true, false);
							break;

							case PERIOD_COLONIAL_POWERS:
								GiveShip2Character(pchar, "FR_Boussole", "La Boussole", -1, FRANCE, true, false);
							break;

							case PERIOD_REVOLUTIONS:
								GiveShip2Character(pchar, "FR_Superbe", "Le Superbe", -1, FRANCE, true, false);
							break;

							case PERIOD_NAPOLEONIC:
								GiveShip2Character(pchar, "FR_BattleFrigate", "L'Artmise", -1, FRANCE, true, false);
							break;
						}
					}
				break;
				case 6: // Capitaine de Vaisseau
					if(pchar.sex != "woman")
					{
						switch(rand(1))
						{
							case 0: GiveModel2Player("fra_cpt_18", true); break;
							case 1: GiveModel2Player("fra_cpt2_18", true); break;
						}
					}
				break;
				case 7: // Contre-Amiral
					GiveModel2Player("fra_cmd_18", true);
					GiveItem2Character(pchar,"blade25"+qual); // French Nobility Sword
					EquipCharacterByItem(pchar,"blade25"+qual);
				break;
				case 8: // Vice-Amiral
				break;
				case 9: // Vice-Amiral d'Escadre
				break;
				case 10: // Amiral
					if(pchar.sex != "woman")
					{
						GiveModel2Player("fra_adm_18", true);
					}
				break;
				case 11: // Amiral d'Escadre
				break;
				case 12: // Amiral de France
				break;
			}
		break;
		case SPAIN:
			switch(GetRank(pchar, GetCurrentLocationNation()))
			{
				case 1: // Alferez
					if(pchar.sex != "woman")
					{
						switch(GetAttribute(pchar,"model"))
						{
							case "blaze":				GiveModel2Player("47_Blaze_spain", true); break;
							case "depp":				GiveModel2Player("47_Sparrow_spain", true); break;
							case "jack":				GiveModel2Player("47_Sparrow_spain", true); break;
							switch (rand(1))
							{
								case 0: GiveModel2Player("spa_mds1_18", true); break;
								case 1: GiveModel2Player("spa_mds2_18", true); break;
							}
						}
					}
					Characters[GetCharacterIndex("Crewmember_01")].model = Nations[SPAIN].fantomModel.m1;
					Characters[GetCharacterIndex("Crewmember_01")].headmodel = "h_"+Nations[SPAIN].fantomModel.m1;
					Characters[GetCharacterIndex("Crewmember_02")].model = Nations[SPAIN].fantomModel.m2;
					Characters[GetCharacterIndex("Crewmember_02")].headmodel = "h_"+Nations[SPAIN].fantomModel.m2;
					Characters[GetCharacterIndex("Crewmember_03")].model = Nations[SPAIN].fantomModel.m3;
					Characters[GetCharacterIndex("Crewmember_03")].headmodel = "h_"+Nations[SPAIN].fantomModel.m3;
					Characters[GetCharacterIndex("Crewmember_04")].model = Nations[SPAIN].fantomModel.m4;
					Characters[GetCharacterIndex("Crewmember_04")].headmodel = "h_"+Nations[SPAIN].fantomModel.m4;
					Characters[GetCharacterIndex("Crewmember_05")].model = Nations[SPAIN].fantomModel.m5;
					Characters[GetCharacterIndex("Crewmember_05")].headmodel = "h_"+Nations[SPAIN].fantomModel.m5;
					Characters[GetCharacterIndex("Treas_Crewmember_1")].model = Nations[SPAIN].fantomModel.m1;
					Characters[GetCharacterIndex("Treas_Crewmember_1")].headmodel = "h_"+Nations[SPAIN].fantomModel.m1;
					Characters[GetCharacterIndex("Treas_Crewmember_2")].model = Nations[SPAIN].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_2")].headmodel = "h_"+Nations[SPAIN].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_3")].model = Nations[SPAIN].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_3")].headmodel = "h_"+Nations[SPAIN].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_4")].model = Nations[SPAIN].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_4")].headmodel = "h_"+Nations[SPAIN].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_5")].model = Nations[SPAIN].fantomModel.m5;
                    Characters[GetCharacterIndex("Treas_Crewmember_5")].headmodel = "h_"+Nations[SPAIN].fantomModel.m5;
					Characters[GetCharacterIndex("Treas_Crewmember_6")].model = Nations[SPAIN].fantomModel.m6;
					Characters[GetCharacterIndex("Treas_Crewmember_6")].headmodel = "h_"+Nations[SPAIN].fantomModel.m6;
					Characters[GetCharacterIndex("Treas_Crewmember_7")].model = Nations[SPAIN].fantomModel.m1;
                    Characters[GetCharacterIndex("Treas_Crewmember_7")].headmodel = "h_"+Nations[SPAIN].fantomModel.m1;
                    Characters[GetCharacterIndex("Treas_Crewmember_8")].model = Nations[SPAIN].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_8")].headmodel = "h_"+Nations[SPAIN].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_9")].model = Nations[SPAIN].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_9")].headmodel = "h_"+Nations[SPAIN].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_10")].model = Nations[SPAIN].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_10")].headmodel = "h_"+Nations[SPAIN].fantomModel.m4;
					pchar.boardingmodels = "SPAIN";
				break;
				case 2: // Seg.-Tenente
					if(pchar.sex != "woman")
					{
						switch (rand(2))
						{
							case 0: GiveModel2Player("spa_lut_18", true); break;
							case 1: GiveModel2Player("spa_lut1_18", true); break;
							case 2: GiveModel2Player("spa_lut2_18", true); break;
						}
					}
					GiveItem2Character(pchar,"blade33"+qual); // Moorish Saber
					EquipCharacterByItem(pchar,"blade33"+qual);
				break;
				case 3: // Teniente
				break;
				case 4: // Capitan de Corbeta
				break;
				case 5: // Capitan de Fragata
					if(PROMOTION_SHIPS)
					{
						ch = CreateOfficer_Cheat(OFFIC_TYPE_FIRSTMATE, "9JdSpa_A3", 3, SPAIN, false);
						ExchangeCharacterShip(ch, pchar);
						SetCompanionIndex(pchar, -1, GetCharacterIndex(ch.id)));
						switch(GetCurrentPeriod())
						{
							case PERIOD_EARLY_EXPLORERS:
								GiveShip2Character(pchar, "SP_BattleGalleon", "Natividad", -1, SPAIN, true, false);
							break;

							case PERIOD_THE_SPANISH_MAIN:
								GiveShip2Character(pchar, "SP_ApostolFelipe", "Apostl Felipe", -1, SPAIN, true, false);
							break;

							case PERIOD_GOLDEN_AGE_OF_PIRACY:
								GiveShip2Character(pchar, "SP_Galeon50", "Santiago el Mayor", -1, SPAIN, true, false);
							break;

							case PERIOD_COLONIAL_POWERS:
								GiveShip2Character(pchar, "SP_Battleship", "Nuestra Senora del Pilar", -1, SPAIN, true, false);
							break;

							case PERIOD_REVOLUTIONS:
								GiveShip2Character(pchar, "SP_SanFelipe", "San Felipe", -1, SPAIN, true, false);
							break;

							case PERIOD_NAPOLEONIC:
								GiveShip2Character(pchar, "SP_Manowar", "San Juan", -1, SPAIN, true, false);
							break;
						}
					}
				break;
				case 6: // Capitan de Navio
					if(pchar.sex != "woman")
					{
						switch(rand(2))
						{
							case 0: GiveModel2Player("spa_cpt_18", true); break;
							case 1: GiveModel2Player("spa_cpt1_18", true); break;
							case 2: GiveModel2Player("spa_cpt2_18", true); break;
						}
					}
					GiveItem2Character(pchar,"blade14"+qual); // Spanish Nobility Longsword
					EquipCharacterByItem(pchar,"blade14"+qual);
				break;
				case 7: // Contra Almirante
				break;
				case 8: // Vice Almirante
				break;
				case 9: // Almirante
				break;
				case 10: // Capitan General
					if(pchar.sex != "woman")
					{
						GiveModel2Player("spa_adm_18", true);
					}
				break;
				case 11: // Almirante General
				break;
				case 12: // Almirante de Armada Espanola
				break;
			}
		break;
		case PORTUGAL:
			switch(GetRank(pchar, GetCurrentLocationNation()))
			{
				case 1: // Aspirante
					Characters[GetCharacterIndex("Crewmember_01")].model = Nations[PORTUGAL].fantomModel.m1;
					Characters[GetCharacterIndex("Crewmember_01")].headmodel = "h_"+Nations[PORTUGAL].fantomModel.m1;
					Characters[GetCharacterIndex("Crewmember_02")].model = Nations[PORTUGAL].fantomModel.m2;
					Characters[GetCharacterIndex("Crewmember_02")].headmodel = "h_"+Nations[PORTUGAL].fantomModel.m2;
					Characters[GetCharacterIndex("Crewmember_03")].model = Nations[PORTUGAL].fantomModel.m3;
					Characters[GetCharacterIndex("Crewmember_03")].headmodel = "h_"+Nations[PORTUGAL].fantomModel.m3;
					Characters[GetCharacterIndex("Crewmember_04")].model = Nations[PORTUGAL].fantomModel.m4;
					Characters[GetCharacterIndex("Crewmember_04")].headmodel = "h_"+Nations[PORTUGAL].fantomModel.m4;
					Characters[GetCharacterIndex("Crewmember_05")].model = Nations[PORTUGAL].fantomModel.m5;
					Characters[GetCharacterIndex("Crewmember_05")].headmodel = "h_"+Nations[PORTUGAL].fantomModel.m5;
					Characters[GetCharacterIndex("Treas_Crewmember_1")].model = Nations[PORTUGAL].fantomModel.m1;
					Characters[GetCharacterIndex("Treas_Crewmember_1")].headmodel = "h_"+Nations[PORTUGAL].fantomModel.m1;
					Characters[GetCharacterIndex("Treas_Crewmember_2")].model = Nations[PORTUGAL].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_2")].headmodel = "h_"+Nations[PORTUGAL].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_3")].model = Nations[PORTUGAL].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_3")].headmodel = "h_"+Nations[PORTUGAL].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_4")].model = Nations[PORTUGAL].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_4")].headmodel = "h_"+Nations[PORTUGAL].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_5")].model = Nations[PORTUGAL].fantomModel.m5;
                    Characters[GetCharacterIndex("Treas_Crewmember_5")].headmodel = "h_"+Nations[PORTUGAL].fantomModel.m5;
					Characters[GetCharacterIndex("Treas_Crewmember_6")].model = Nations[PORTUGAL].fantomModel.m6;
					Characters[GetCharacterIndex("Treas_Crewmember_6")].headmodel = "h_"+Nations[PORTUGAL].fantomModel.m6;
					Characters[GetCharacterIndex("Treas_Crewmember_7")].model = Nations[PORTUGAL].fantomModel.m1;
                    Characters[GetCharacterIndex("Treas_Crewmember_7")].headmodel = "h_"+Nations[PORTUGAL].fantomModel.m1;
                    Characters[GetCharacterIndex("Treas_Crewmember_8")].model = Nations[PORTUGAL].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_8")].headmodel = "h_"+Nations[PORTUGAL].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_9")].model = Nations[PORTUGAL].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_9")].headmodel = "h_"+Nations[PORTUGAL].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_10")].model = Nations[PORTUGAL].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_10")].headmodel = "h_"+Nations[PORTUGAL].fantomModel.m4;
					pchar.boardingmodels = "PORTUGAL";
				break;
				case 2: // Seg.-Tenente
					GiveItem2Character(pchar,"blade29"+qual); // Portugese Officer's Sword
					EquipCharacterByItem(pchar,"blade29"+qual);
				break;
				case 3: // Tenente
				break;
				case 4: // Capitao-Tenente
				break;
				case 5: // Capitao-de-Fragata
					if(PROMOTION_SHIPS)
					{
						ch = CreateOfficer_Cheat(OFFIC_TYPE_FIRSTMATE, "9JdSPor_A3", 3, PORTUGAL, false);
						ExchangeCharacterShip(ch, pchar);
						SetCompanionIndex(pchar, -1, GetCharacterIndex(ch.id)));
						switch(GetCurrentPeriod())
						{
							case PERIOD_EARLY_EXPLORERS:
								GiveShip2Character(pchar, "PO_CaravelR", "Santa Mara", -1, PORTUGAL, true, false);
							break;

							case PERIOD_THE_SPANISH_MAIN:
								GiveShip2Character(pchar, "PO_Caravel50", "So Gabriel", -1, PORTUGAL, true, false);
							break;

							case PERIOD_GOLDEN_AGE_OF_PIRACY:
								GiveShip2Character(pchar, "PO_Fleut50", "Cinco Chagas", -1, PORTUGAL, true, false);
							break;

							case PERIOD_COLONIAL_POWERS:
								GiveShip2Character(pchar, "PO_FastNavy", "Misericrdia", -1, PORTUGAL, true, false);
							break;

							case PERIOD_REVOLUTIONS:
								GiveShip2Character(pchar, "PO_Poseidon", "Santo Antnio", -1, PORTUGAL, true, false);
							break;

							case PERIOD_NAPOLEONIC:
								GiveShip2Character(pchar, "PO_Manowar", "So Sebastio", -1, PORTUGAL, true, false);
							break;
						}
					}
				break;
				case 6: // Capitao-de-Mar-e-Guerra
				break;
				case 7: // Comodoro
					GiveItem2Character(pchar,"blade32"+qual); // Damascus Shamshir
					EquipCharacterByItem(pchar,"blade32"+qual);
				break;
				case 8: // Contra-Almirante
				break;
				case 9: // Vice-Almirante
				break;
				case 10: // Almirante
				break;
				case 11: // Almirante da Armada
				break;
				case 12: // Almirante da Marinha de Guerra Portuguesa
				break;
			}
		break;
		case AMERICA:
			switch(GetRank(pchar, GetCurrentLocationNation()))
			{
				case 1: // Ensign
					Characters[GetCharacterIndex("Crewmember_01")].model = Nations[AMERICA].fantomModel.m1;
					Characters[GetCharacterIndex("Crewmember_01")].headmodel = "h_"+Nations[AMERICA].fantomModel.m1;
					Characters[GetCharacterIndex("Crewmember_02")].model = Nations[AMERICA].fantomModel.m2;
					Characters[GetCharacterIndex("Crewmember_02")].headmodel = "h_"+Nations[AMERICA].fantomModel.m2;
					Characters[GetCharacterIndex("Crewmember_03")].model = Nations[AMERICA].fantomModel.m3;
					Characters[GetCharacterIndex("Crewmember_03")].headmodel = "h_"+Nations[AMERICA].fantomModel.m3;
					Characters[GetCharacterIndex("Crewmember_04")].model = Nations[AMERICA].fantomModel.m4;
					Characters[GetCharacterIndex("Crewmember_04")].headmodel = "h_"+Nations[AMERICA].fantomModel.m4;
					Characters[GetCharacterIndex("Crewmember_05")].model = Nations[AMERICA].fantomModel.m5;
					Characters[GetCharacterIndex("Crewmember_05")].headmodel = "h_"+Nations[AMERICA].fantomModel.m5;
					Characters[GetCharacterIndex("Treas_Crewmember_1")].model = Nations[AMERICA].fantomModel.m1;
					Characters[GetCharacterIndex("Treas_Crewmember_1")].headmodel = "h_"+Nations[AMERICA].fantomModel.m1;
					Characters[GetCharacterIndex("Treas_Crewmember_2")].model = Nations[AMERICA].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_2")].headmodel = "h_"+Nations[AMERICA].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_3")].model = Nations[AMERICA].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_3")].headmodel = "h_"+Nations[AMERICA].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_4")].model = Nations[AMERICA].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_4")].headmodel = "h_"+Nations[AMERICA].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_5")].model = Nations[AMERICA].fantomModel.m5;
                    Characters[GetCharacterIndex("Treas_Crewmember_5")].headmodel = "h_"+Nations[AMERICA].fantomModel.m5;
					Characters[GetCharacterIndex("Treas_Crewmember_6")].model = Nations[AMERICA].fantomModel.m6;
					Characters[GetCharacterIndex("Treas_Crewmember_6")].headmodel = "h_"+Nations[AMERICA].fantomModel.m6;
					Characters[GetCharacterIndex("Treas_Crewmember_7")].model = Nations[AMERICA].fantomModel.m1;
                    Characters[GetCharacterIndex("Treas_Crewmember_7")].headmodel = "h_"+Nations[AMERICA].fantomModel.m1;
                    Characters[GetCharacterIndex("Treas_Crewmember_8")].model = Nations[AMERICA].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_8")].headmodel = "h_"+Nations[AMERICA].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_9")].model = Nations[AMERICA].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_9")].headmodel = "h_"+Nations[AMERICA].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_10")].model = Nations[AMERICA].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_10")].headmodel = "h_"+Nations[AMERICA].fantomModel.m4;
					pchar.boardingmodels = "AMERICA";
				break;
				case 2: // Junior Lieutenant
					if(pchar.sex != "woman")
					{
						GiveModel2Player("USA_lut_18", true);
					}
				break;
				case 3: // Lieutenant
				break;
				case 4: // Senior Lieutenant
				break;
				case 5: // Commander
					GiveItem2Character(pchar,"blade43"+qual); // US Cavalry Saber
					EquipCharacterByItem(pchar,"blade43"+qual);
 
					if(PROMOTION_SHIPS)
					{
						ch = CreateOfficer_Cheat(OFFIC_TYPE_FIRSTMATE, "USA_lut_18", 3, AMERICA, false);
						ExchangeCharacterShip(ch, pchar);
						SetCompanionIndex(pchar, -1, GetCharacterIndex(ch.id)));
						switch(GetCurrentPeriod())
						{
							case PERIOD_REVOLUTIONS:
								GiveShip2Character(pchar, "USS_Constitution", "USS Constitution", -1, AMERICA, true, false);
							break;

							case PERIOD_NAPOLEONIC:
								GiveShip2Character(pchar, "US_SteamFrigate", "USS Hudson", -1, AMERICA, true, false);
							break;
						}
					}
				break;
				case 6: // Captain
					if(pchar.sex != "woman")
					{
						GiveModel2Player("USA_cpt_18", true);
					}
				break;
				case 7: // Commodore
				break;
				case 8: // Rear Admiral
					if(pchar.sex != "woman")
					{
						GiveModel2Player("USA_adm_18", true);
					}
				break;
				case 9: // Vice Admiral
				break;
				case 10: // Admiral
				break;
				case 11: // Fleet Admiral
				break;
				case 12: // Chief of Naval Operations
				break;
			}
		break;
		case PIRATE: // Apparently used by Sao Feng, the Turks governor in the Jack Sparrow storyline
			switch(GetRank(pchar, GetCurrentLocationNation()))
			{
				case 1:
					Characters[GetCharacterIndex("Crewmember_01")].model = Nations[PIRATE].fantomModel.m1;
					Characters[GetCharacterIndex("Crewmember_01")].headmodel = "h_"+Nations[PIRATE].fantomModel.m1;
					Characters[GetCharacterIndex("Crewmember_02")].model = Nations[PIRATE].fantomModel.m2;
					Characters[GetCharacterIndex("Crewmember_02")].headmodel = "h_"+Nations[PIRATE].fantomModel.m2;
					Characters[GetCharacterIndex("Crewmember_03")].model = Nations[PIRATE].fantomModel.m3;
					Characters[GetCharacterIndex("Crewmember_03")].headmodel = "h_"+Nations[PIRATE].fantomModel.m3;
					Characters[GetCharacterIndex("Crewmember_04")].model = Nations[PIRATE].fantomModel.m4;
					Characters[GetCharacterIndex("Crewmember_04")].headmodel = "h_"+Nations[PIRATE].fantomModel.m4;
					Characters[GetCharacterIndex("Crewmember_05")].model = Nations[PIRATE].fantomModel.m5;
					Characters[GetCharacterIndex("Crewmember_05")].headmodel = "h_"+Nations[PIRATE].fantomModel.m5;
					Characters[GetCharacterIndex("Treas_Crewmember_1")].model = Nations[PIRATE].fantomModel.m1;
					Characters[GetCharacterIndex("Treas_Crewmember_1")].headmodel = "h_"+Nations[PIRATE].fantomModel.m1;
					Characters[GetCharacterIndex("Treas_Crewmember_2")].model = Nations[PIRATE].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_2")].headmodel = "h_"+Nations[PIRATE].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_3")].model = Nations[PIRATE].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_3")].headmodel = "h_"+Nations[PIRATE].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_4")].model = Nations[PIRATE].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_4")].headmodel = "h_"+Nations[PIRATE].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_5")].model = Nations[PIRATE].fantomModel.m5;
                    Characters[GetCharacterIndex("Treas_Crewmember_5")].headmodel = "h_"+Nations[PIRATE].fantomModel.m5;
					Characters[GetCharacterIndex("Treas_Crewmember_6")].model = Nations[PIRATE].fantomModel.m6;
					Characters[GetCharacterIndex("Treas_Crewmember_6")].headmodel = "h_"+Nations[PIRATE].fantomModel.m6;
					Characters[GetCharacterIndex("Treas_Crewmember_7")].model = Nations[PIRATE].fantomModel.m1;
                    Characters[GetCharacterIndex("Treas_Crewmember_7")].headmodel = "h_"+Nations[PIRATE].fantomModel.m1;
                    Characters[GetCharacterIndex("Treas_Crewmember_8")].model = Nations[PIRATE].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_8")].headmodel = "h_"+Nations[PIRATE].fantomModel.m2;
                    Characters[GetCharacterIndex("Treas_Crewmember_9")].model = Nations[PIRATE].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_9")].headmodel = "h_"+Nations[PIRATE].fantomModel.m3;
                    Characters[GetCharacterIndex("Treas_Crewmember_10")].model = Nations[PIRATE].fantomModel.m4;
                    Characters[GetCharacterIndex("Treas_Crewmember_10")].headmodel = "h_"+Nations[PIRATE].fantomModel.m4;
					pchar.boardingmodels = "PIRATE";
				break;
				case 2: // Aviator543
					GiveItem2Character(pchar,"blade34+2"); // Dragon's Head
					EquipCharacterByItem(pchar,"blade34+2");
				break;
			}
		break;
/*		case EITC: // UNUSED: Just to remind us to use those models at some point
			switch(GetRank(pchar, GetCurrentLocationNation()))
			{
				case 2: // Lieutenant
					if(pchar.model == "blaze")				pchar.model = "47Blaze_Eitc_lt";
					if(pchar.model == "depp")				pchar.model = "47_Sparrow_Eitc_lt";
				break;
				case 4: // Captain
					if(pchar.model == "47Blaze_Eitc_lt")	pchar.model = "47Blaze_Eitc_cpt";
					if(pchar.model == 47_Sparrow_Eitc_lt")	pchar.model = "47_Sparrow_Eitc_cpt";
				break;
			}
		break;
*/
	}
}

bool KrakenAttackEnabled()
{
	ref pchar = GetMainCharacter();
	if(GetAttribute(pchar, "ship.type") != "CursedDutchman")		return false;	// Only the CURSED Flying Dutchman can call upon the Kraken
	if(CheckAttribute(pchar, "KrakenAttack"))						return false;	// No Kraken attack is available until a set time after the previous attack
	if(CheckAttribute(pchar, "ship.SubmergeDutchman"))				return false;	// No Kraken attack is available while the Dutchman is submerged
	return true;
}

void KrakenAttack(aref rCharacter, int iSwimQuantity)
// Character and number of tentacles
{
	if (!bSeaActive) return;
	ref pchar = GetMainCharacter();
	int delay = 0;
	for (int i=0; i < iSwimQuantity; i++)
	{
		PostEvent("CreateKrakenTentacle", delay, "i", rCharacter);
		delay = delay + rand(1000);
	}
	if(IsMainCharacter(rCharacter)) LogIt("Captain, we're being attacked by the Kraken!");
	else
	{
		LogIt("Captain, the " + rCharacter.ship.name + " is under attack by the Kraken!");
		pchar.KrakenAttack = true;
	}
	PostEvent("KrakenAttackFinished", delay, "i", rCharacter);
}

#event_handler("KrakenAttackFinished", "FinishKrakenAttack");
void FinishKrakenAttack()
{
	ref pchar = GetMainCharacter();
	aref rCharacter = GetEventData();
	LogIt("Captain, the Kraken has finished its attack on the " + rCharacter.ship.name + "!");
	if(CheckAttribute(pchar, "KrakenAttack"))	PostEvent("EnableKraken", 5*60*1000);
}

#event_handler("EnableKraken", "KrakenEnabled");
void KrakenEnabled()
{
	ref pchar = GetMainCharacter();
	DeleteAttribute(pchar, "KrakenAttack");
	LogIt("Captain, the Kraken is ready for another attack!");
}

#event_handler("CreateKrakenTentacle", "KrakenTentacle");
void KrakenTentacle()
{
	if (!bSeaActive) return;
	aref rCharacter = GetEventData();
	if(CheckAttribute(rCharacter,"Ship"))
	{
		switch(rand(15))
		{
			case  0: Direct_AddGood(rCharacter, "Oil", "tentacle1_0",  0.0,105,10+rand(40),Degree2Radian(rand(20)-10)+Degree2Radian(135.0)-stf(rCharacter.Ship.Ang.y)); break;
			case  1: Direct_AddGood(rCharacter, "Oil", "tentacle1_90", 0.0,105,10+rand(40),Degree2Radian(rand(20)-10)+Degree2Radian(225.0)-stf(rCharacter.Ship.Ang.y)); break;
			case  2: Direct_AddGood(rCharacter, "Oil", "tentacle1_180",0.0,105,10+rand(40),Degree2Radian(rand(20)-10)+Degree2Radian(315.0)-stf(rCharacter.Ship.Ang.y)); break;
			case  3: Direct_AddGood(rCharacter, "Oil", "tentacle1_270",0.0,105,10+rand(40),Degree2Radian(rand(20)-10)+Degree2Radian(45.0) -stf(rCharacter.Ship.Ang.y)); break;
			case  4: Direct_AddGood(rCharacter, "Oil", "tentacle2_0",  0.0,105, 5+rand(40),Degree2Radian(rand(20)-10)+Degree2Radian(70.0) -stf(rCharacter.Ship.Ang.y)); break;
			case  5: Direct_AddGood(rCharacter, "Oil", "tentacle2_90", 0.0,105, 5+rand(40),Degree2Radian(rand(20)-10)+Degree2Radian(160.0)-stf(rCharacter.Ship.Ang.y)); break;
			case  6: Direct_AddGood(rCharacter, "Oil", "tentacle2_180",0.0,105, 5+rand(40),Degree2Radian(rand(20)-10)+Degree2Radian(250.0)-stf(rCharacter.Ship.Ang.y)); break;
			case  7: Direct_AddGood(rCharacter, "Oil", "tentacle2_270",0.0,105, 5+rand(40),Degree2Radian(rand(20)-10)+Degree2Radian(340.0)-stf(rCharacter.Ship.Ang.y)); break;
			case  8: Direct_AddGood(rCharacter, "Oil", "tentacle3_0",  0.0,105,10+rand(20),Degree2Radian(rand(20)-10)+Degree2Radian(90.0) -stf(rCharacter.Ship.Ang.y)); break;
			case  9: Direct_AddGood(rCharacter, "Oil", "tentacle3_90", 0.0,105,10+rand(20),Degree2Radian(rand(20)-10)+Degree2Radian(180.0)-stf(rCharacter.Ship.Ang.y)); break;
			case 10: Direct_AddGood(rCharacter, "Oil", "tentacle3_180",0.0,105,10+rand(20),Degree2Radian(rand(20)-10)+Degree2Radian(270.0)-stf(rCharacter.Ship.Ang.y)); break;
			case 11: Direct_AddGood(rCharacter, "Oil", "tentacle3_270",0.0,105,10+rand(20),Degree2Radian(rand(20)-10)+Degree2Radian(0.0)  -stf(rCharacter.Ship.Ang.y)); break;
			case 12: Direct_AddGood(rCharacter, "Oil", "tentacle4_0",  0.0,105, 5+rand(20),Degree2Radian(rand(20)-10)+Degree2Radian(90.0) -stf(rCharacter.Ship.Ang.y)); break;
			case 13: Direct_AddGood(rCharacter, "Oil", "tentacle4_90", 0.0,105, 5+rand(20),Degree2Radian(rand(20)-10)+Degree2Radian(180.0)-stf(rCharacter.Ship.Ang.y)); break;
			case 14: Direct_AddGood(rCharacter, "Oil", "tentacle4_180",0.0,105, 5+rand(20),Degree2Radian(rand(20)-10)+Degree2Radian(270.0)-stf(rCharacter.Ship.Ang.y)); break;
			case 15: Direct_AddGood(rCharacter, "Oil", "tentacle4_270",0.0,105, 5+rand(20),Degree2Radian(rand(20)-10)+Degree2Radian(0.0)  -stf(rCharacter.Ship.Ang.y)); break;
		}
	}
}

#event_handler("UpdateDutchmanSubmersion", "SubmergeDutchman");
void SubmergeDutchman()
{
	aref rCharacter = GetEventData();

	if(CheckAttribute(rCharacter, "ship.SubmergeDutchman"))
	{
		float fX, fY, fZ, fAY, gX, gY, gZ;
		fX = 0; fY = 0; fZ = 0;
		if(CheckAttribute(rCharacter,"Ship.pos.x")) fX=stf(rCharacter.Ship.pos.x);
			else return;
		if(CheckAttribute(rCharacter,"Ship.pos.y")) fY=stf(rCharacter.Ship.pos.y);
			else return;
		if(CheckAttribute(rCharacter,"Ship.pos.z")) fZ=stf(rCharacter.Ship.pos.z);
			else return;
		if(CheckAttribute(rCharacter,"Ship.Ang.y")) fAY=stf(rCharacter.Ship.Ang.y);
			else return;
		rCharacter.firedrill = true;
		if(!CheckAttribute(rCharacter, "ship.EmergeDutchman"))
		{
			rCharacter.ship.SubmergeDutchman = makefloat(rCharacter.ship.SubmergeDutchman) + 0.5;
			if(!CheckAttribute(rCharacter, "ship.PlayedSplash"))
			{
				rCharacter.ship.PlayedSplash = 1;
				gX =  0; gY = 0; gZ = 30;
				CreateParticleSystemX("dutchman_submerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  5; gY = 0; gZ = 20;
				CreateParticleSystemX("dutchman_submerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX = -5; gY = 0; gZ = 20;
				CreateParticleSystemX("dutchman_submerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  5; gY = 0; gZ = 10;
				CreateParticleSystemX("dutchman_submerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX = -5; gY = 0; gZ = 10;
				CreateParticleSystemX("dutchman_submerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  5; gY = 0; gZ = 0;
				CreateParticleSystemX("dutchman_submerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX = -5; gY = 0; gZ = 0;
				CreateParticleSystemX("dutchman_submerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  5; gY = 0; gZ = -10;
				CreateParticleSystemX("dutchman_submerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX = -5; gY = 0; gZ = -10;
				CreateParticleSystemX("dutchman_submerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  5; gY = 0; gZ = -20;
				CreateParticleSystemX("dutchman_submerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX = -5; gY = 0; gZ = -20;
				CreateParticleSystemX("dutchman_submerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  0; gY = 0; gZ = -30;
				CreateParticleSystemX("dutchman_submerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				PlayStereoSound("objects\shipcharge\take_prey.wav");
			}
			if(stf(rCharacter.ship.SubmergeDutchman) >= 53)
			{
				rCharacter.ship.SubmergeDutchman = 53;
			}
			rCharacter.ship.immersion = rCharacter.ship.SubmergeDutchman;
		}
		else
		{
			rCharacter.ship.SubmergeDutchman =  makefloat(rCharacter.ship.SubmergeDutchman) - 0.5;
			if(stf(rCharacter.ship.SubmergeDutchman)-50 <= stf(rCharacter.ship.CorrectImmersion) && !CheckAttribute(rCharacter, "ship.PlayedSplash"))
			{
				gX =  0; gY = 52 - stf(rCharacter.ship.SubmergeDutchman); gZ = -2;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				PlayStereoSound("objects\shipcharge\ball_splash1.wav");
				rCharacter.ship.PlayedSplash = 1;
			}
			if(stf(rCharacter.ship.SubmergeDutchman)-45 <= stf(rCharacter.ship.CorrectImmersion) && sti(GetAttribute(rCharacter, "ship.PlayedSplash")) == 1)
			{
				gX = 0; gY = 45 - stf(rCharacter.ship.SubmergeDutchman); gZ = 16;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				PlayStereoSound("objects\shipcharge\ball_splash1.wav");
				rCharacter.ship.PlayedSplash = 2;
			}
			if(stf(rCharacter.ship.SubmergeDutchman)-35 <= stf(rCharacter.ship.CorrectImmersion) && sti(GetAttribute(rCharacter, "ship.PlayedSplash")) == 2)
			{
				gX = 0; gY = 35 - stf(rCharacter.ship.SubmergeDutchman); gZ = -13;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				PlayStereoSound("objects\shipcharge\ball_splash1.wav");
				rCharacter.ship.PlayedSplash = 3;
			}
			if(stf(rCharacter.ship.SubmergeDutchman)-10 <= stf(rCharacter.ship.CorrectImmersion) && sti(GetAttribute(rCharacter, "ship.PlayedSplash")) == 3)
			{
				gX =  0; gY = 0; gZ = 30;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  5; gY = 0; gZ = 25;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX = -5; gY = 0; gZ = 25;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  5; gY = 0; gZ = 20;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX = -5; gY = 0; gZ = 20;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  5; gY = 0; gZ = 15;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX = -5; gY = 0; gZ = 15;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  5; gY = 0; gZ = 10;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX = -5; gY = 0; gZ = 10;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  5; gY = 0; gZ = 5;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX = -5; gY = 0; gZ = 5;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  5; gY = 0; gZ = 0;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX = -5; gY = 0; gZ = 0;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  5; gY = 0; gZ = -5;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX = -5; gY = 0; gZ = -5;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  5; gY = 0; gZ = -10;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX = -5; gY = 0; gZ = -10;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  5; gY = 0; gZ = -15;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX = -5; gY = 0; gZ = -15;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  5; gY = 0; gZ = -20;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX = -5; gY = 0; gZ = -20;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  5; gY = 0; gZ = -25;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX = -5; gY = 0; gZ = -25;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				gX =  0; gY = 0; gZ = -30;
				CreateParticleSystemX("dutchman_emerge",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 3.0, 0.0, 2);
				PlayStereoSound("objects\shipcharge\ball_splash1.wav");
				rCharacter.ship.PlayedSplash = 4;
			}
			if(stf(rCharacter.ship.SubmergeDutchman) <= stf(rCharacter.ship.CorrectImmersion))
			{
				rCharacter.ship.immersion = rCharacter.ship.CorrectImmersion;
				Ship_ChangeCharge(rCharacter, sti(rCharacter.Ship.Cannons.Charge.Type)); // Reload cannons
				DeleteAttribute(rCharacter, "ship.SubmergeDutchman");
				DeleteAttribute(rCharacter, "ship.EmergeDutchman");
				DeleteAttribute(rCharacter, "ship.PlayedSplash");
			}
			else
				rCharacter.ship.immersion = rCharacter.ship.SubmergeDutchman;
		}
	}
}

#event_handler("CreateCursedPearlFog", "CursedPearlFog");
void CursedPearlFog()
{
	aref rCharacter = GetEventData();
	float fX, fY, fZ, fAY;
	fX = 0; fY = 0; fZ = 0;

	if(CheckAttribute(rCharacter,"Ship.pos.x")) fX=stf(rCharacter.Ship.pos.x);
		else return;
	if(CheckAttribute(rCharacter,"Ship.pos.y")) fY=stf(rCharacter.Ship.pos.y);
		else return;
	if(CheckAttribute(rCharacter,"Ship.pos.z")) fZ=stf(rCharacter.Ship.pos.z);
		else return;
	if(CheckAttribute(rCharacter,"Ship.Ang.y")) fAY=stf(rCharacter.Ship.Ang.y);
		else return;
	float gX, gY, gZ;
	gX = 0; // Width
	gY = 0; // Height
	gZ = 10; // Length
	CreateParticleSystemX("pearlfog",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), 0.0, 0.0, 0.0, 2);
}

bool BPSweepsEnabled()
{
	ref pchar = GetMainCharacter();
	if(sti(GetAttribute(pchar, "ship.type")) != SHIP_CURSED)		return false;	// Only the Cursed Black Pearl can use the sweeps
	if(CheckAttribute(pchar, "ship.speedburst"))					return false;	// Sweeps cannot be used for a certain period of time
	return true;
}

bool QARSwordEnabled()
{
	ref pchar = GetMainCharacter();
	if(GetAttribute(pchar, "ship.type") != "QueenAnnesRevenge")		return false;	// Only the Queen Anne's Revenge can use Triton's sword
	if(CheckAttribute(pchar, "ship.speedburst"))					return false;	// Sweeps cannot be used for a certain period of time
	return true;
}

#event_handler("FinishSpeedBurst", "FinishedSpeedBurst");
void FinishedSpeedBurst()
{
	ref pchar = GetMainCharacter();
	PostEvent("SpeedBurstFinished",120000, "i", pchar);
	pchar.Ship.Impulse.Rotate.z = 0.0;
	if(sti(GetAttribute(pchar, "ship.type")) == SHIP_CURSED)	DelPerkFromActiveList("PearlSweeps");
	if(GetAttribute(pchar, "ship.type") == "QueenAnnesRevenge")	DelPerkFromActiveList("QARSword");
}

#event_handler("SpeedBurstFinished", "SpeedBurstAvailable");
void SpeedBurstAvailable()
{
	ref pchar = GetMainCharacter();
	DeleteAttribute(pchar, "ship.speedburst");
	if(sti(GetAttribute(pchar, "ship.type")) == SHIP_CURSED)	LogIt("Captain, the crew is ready for another go at the oars!");
	if(GetAttribute(pchar, "ship.type") == "QueenAnnesRevenge")	LogIt("Captain, the Sword of Triton has recharged itself!");
}

void StackSteam(aref rCharacter, int puffs_per_second)
// Character and number of tentacles
{
	if (!bSeaActive) return;
	bool PlayEngineSound = false;
	int delay = 0;

	// Particle Effects
	for (int i=0; i < puffs_per_second; i++)
	{
		PostEvent("CreateStackSteam", delay, "i", rCharacter);
		delay = delay + 1000/puffs_per_second;
	}

	if(IsMainCharacter(rCharacter) && abs(sti(GetAttribute(rCharacter,"Ship.Power"))) > 0)
	{
		// Sound
		if(!CheckAttribute(rCharacter,"Ship.PlayedEngineSound"))
		{
			rCharacter.Ship.PlayedEngineSound = GetSeaTime();
			PlayEngineSound = true;
		}
		if(GetSeaTime() >= sti(rCharacter.Ship.PlayedEngineSound) + sti(rCharacter.basetime)) PlayEngineSound = true;

		if(PlayEngineSound)
		{
			int SoundID;
			SoundID = PlayStereoSound("objects\engine.wav");
			float volume;
			volume = 0.1 + 0.9*abs(stf(GetAttribute(rCharacter,"Ship.Power")))/100;
			SendMessage(Sound,"llf",MSG_SOUND_SET_VOLUME, SoundID, volume);
			rCharacter.Ship.PlayedEngineSound = GetSeaTime();
		}

		// Fuel Consumption
		if(!CheckAttribute(rCharacter,"Ship.FuelConsumption"))	rCharacter.Ship.FuelConsumption = 0;
		else	rCharacter.Ship.FuelConsumption = stf(rCharacter.Ship.FuelConsumption) + abs(stf(GetAttribute(rCharacter,"Ship.Power")))/100;
		if(stf(rCharacter.Ship.FuelConsumption) >= 60)
		{
			RemoveCharacterGoods(rCharacter,GOOD_PLANKS,1);
			rCharacter.Ship.FuelConsumption = 0;
		}
	}
}

#event_handler("CreateStackSteam", "StackSteamPuff");
void StackSteamPuff()
{
	if (!bSeaActive) return;
	aref rCharacter = GetEventData();

	float fX, fY, fZ, fAY;
	fX = 0; fY = 0; fZ = 0;
	if(CheckAttribute(rCharacter,"Ship.pos.x")) fX=stf(rCharacter.Ship.pos.x);
		else return;
	if(CheckAttribute(rCharacter,"Ship.pos.y")) fY=stf(rCharacter.Ship.pos.y);
		else return;
	if(CheckAttribute(rCharacter,"Ship.pos.z")) fZ=stf(rCharacter.Ship.pos.z);
		else return;
	if(CheckAttribute(rCharacter,"Ship.Ang.y")) fAY=stf(rCharacter.Ship.Ang.y);
		else return;

	float gX, gY, gZ;
	gX = 0; gY = 0; gZ = 0;
	gX=GetCharacterShipValue(rCharacter, "stack1X");
	gY=GetCharacterShipValue(rCharacter, "stack1Y");
	float comp = 0.75 * sti(rCharacter.Ship.Speed.z);
	gZ=GetCharacterShipValue(rCharacter, "stack1Z") + comp; // PB: Not a proper fix, but appears better at speed
	CreateParticleSystemX("steamer_smoke",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), Whr_GetWindSpeed()*sin(Whr_GetWindAngle()), 10*Degree2Radian(90.0), Whr_GetWindSpeed()*cos(Whr_GetWindAngle()), 0);

	if(HasCharacterShipAttribute(rCharacter, "stack2X") || HasCharacterShipAttribute(rCharacter, "stack2Y") || HasCharacterShipAttribute(rCharacter, "stack2Z"))
	{
		gX = 0; gY = 0; gZ = 0;
		gX=GetCharacterShipValue(rCharacter, "stack2X");
		gY=GetCharacterShipValue(rCharacter, "stack2Y");
		gZ=GetCharacterShipValue(rCharacter, "stack2Z") + comp; // PB: Not a proper fix, but appears better at speed
		CreateParticleSystemX("steamer_smoke2",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), Whr_GetWindSpeed()*sin(Whr_GetWindAngle()), 10*Degree2Radian(90.0), Whr_GetWindSpeed()*cos(Whr_GetWindAngle()), 0);
	}

	if(abs(sti(GetAttribute(rCharacter,"Ship.Power"))) > 0)
	{
		if(sti(GetAttribute(rCharacter,"Ship.Power")) < 0)
		{
			fAY = fAY + PI;
		}
		if(HasCharacterShipAttribute(rCharacter, "prop1X") || HasCharacterShipAttribute(rCharacter, "prop1Y") || HasCharacterShipAttribute(rCharacter, "prop1Z"))
		{
			gX = 0; gY = 0; gZ = 0;
			gX=GetCharacterShipValue(rCharacter, "prop1X");
			gY=GetCharacterShipValue(rCharacter, "prop1Y");
			gZ=GetCharacterShipValue(rCharacter, "prop1Z");
			CreateParticleSystemX("steamer_wake",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), sin(fAY), 0.0, cos(fAY), 0);
		}

		if(HasCharacterShipAttribute(rCharacter, "prop2X") || HasCharacterShipAttribute(rCharacter, "prop2Y") || HasCharacterShipAttribute(rCharacter, "prop2Z"))
		{
			gX = 0; gY = 0; gZ = 0;
			gX=GetCharacterShipValue(rCharacter, "prop2X");
			gY=GetCharacterShipValue(rCharacter, "prop2Y");
			gZ=GetCharacterShipValue(rCharacter, "prop2Z");
			CreateParticleSystemX("steamer_wake",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), sin(fAY), 0.0, cos(fAY), 0);
		}
	}
// PB: Testing -->
/*
	gX = -3; gY = 12; gZ = -23;
	CreateParticleSystemX("stern_light",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), sin(fAY), 0.0, cos(fAY), 0);
	gX = 3; gY = 12; gZ = -23;
	CreateParticleSystemX("stern_light",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), sin(fAY), 0.0, cos(fAY), 0);
	gX = 0; gY = 13; gZ = -23;
	CreateParticleSystemX("stern_light",fX - gX*cos(fAY) + gZ*sin(fAY), fY + gY, fZ + gX*sin(fAY) + gZ*cos(fAY), sin(fAY), 0.0, cos(fAY), 0);
*/
// PB: Testing <--
}

void UpdateShipPower()
{
	ref rCharacter = GetMainCharacter();
	string sshippower = "";
	IShipPower.Log.color = COLOR_NORMAL;
	if(SteamShip(rCharacter))
	{
		switch(abs(sti(GetAttribute(rCharacter,"Ship.Power"))))
		{
			case  100:	sshippower = "Engines: Full";
				IShipPower.Log.color = COLOR_GREEN;
				if(sti(GetAttribute(rCharacter,"Ship.Power")) < 0)
					IShipPower.Log.color = COLOR_RED;
			break;
			case   75:	sshippower = "Engines: Half";
				IShipPower.Log.color = COLOR_GREEN_LIGHT;
				if(sti(GetAttribute(rCharacter,"Ship.Power")) < 0)
					IShipPower.Log.color = COLOR_RED_LIGHT;
			break;
			case   50:	sshippower = "Engines: Slow";
				IShipPower.Log.color = COLOR_YELLOW;
			break;
			case   25:	sshippower = "Engines: Dead Slow";
				IShipPower.Log.color = COLOR_YELLOW_LIGHT;
			break;
			case    0:	sshippower = "Engines: ALL STOP";
				IShipPower.Log.color = COLOR_NORMAL;
			break;
		}
		if(sti(GetAttribute(rCharacter,"Ship.Power")) > 0)
			sshippower = sshippower + " Ahead";
		if(sti(GetAttribute(rCharacter,"Ship.Power")) < 0)
			sshippower = sshippower + " Astern";
		if(GetCargoGoods(rCharacter, GOOD_PLANKS) < 1)
		{
			sshippower = "Engines: NO FUEL";
			IShipPower.Log.color = COLOR_BLUE;
		}
	}
	SendMessage(&IShipPower, "lll", LOG_AND_ACTIONS_INIT, false, true);
	SendMessage(&IShipPower, "lls", LOG_ADD_STRING, true, sshippower);
}

// Capsizing -->
#define ROLL_ANGLE_WARNING 11 // Armada: For testing purposes, you can decrease any of the values on the left
#define ROLL_ANGLE_MORALE  12 // to make the various events occur more easily.
#define ROLL_ANGLE_GOODS   13
#define ROLL_ANGLE_DAMAGE  14
#define ROLL_ANGLE_CAPSIZE 15

void UpdateShipRoll()
{
	ref rCharacter = GetMainCharacter();
	if(Whr_IsStorm() && CheckAttribute(rCharacter,"Capsize") && GetCharacterShipClass(rCharacter) < 8)
	{
		int RollDamageValue;
		int i;
		string sshiproll;
		float fX = stf(rCharacter.Ship.pos.x);
		float fY = stf(rCharacter.Ship.pos.y);
		float fZ = stf(rCharacter.Ship.pos.z);
		float RollAngle = makeint(-Radian2Degree(stf(GetAttribute(rCharacter, "ship.ang.z"))));
		if(RollAngle < -180) RollAngle = RollAngle + 360;

		if(RollAngle > 0 )	sshiproll = "Roll angle is " + abs(makeint(RollAngle)) + " degrees to starboard";
		else				sshiproll = "Roll angle is " + abs(makeint(RollAngle)) + " degrees to port";
		if(RollAngle == 0)	sshiproll = "Roll angle is " + abs(makeint(RollAngle)) + " degrees";

		switch(sti(GetAttribute(rCharacter, "Capsize.Warning")))
		{
			case ROLL_ANGLE_WARNING: // First Warning
				IShipRoll.Log.color = COLOR_NORMAL;
				if(abs(RollAngle) >  ROLL_ANGLE_WARNING) IShipRoll.Log.color = COLOR_GREEN_LIGHT;
				if(abs(RollAngle) >  ROLL_ANGLE_MORALE ) IShipRoll.Log.color = COLOR_GREEN;
				if(abs(RollAngle) >  ROLL_ANGLE_GOODS  ) IShipRoll.Log.color = COLOR_YELLOW;
				if(abs(RollAngle) >  ROLL_ANGLE_DAMAGE ) IShipRoll.Log.color = COLOR_RED_LIGHT;
				if(abs(RollAngle) >  ROLL_ANGLE_CAPSIZE) IShipRoll.Log.color = COLOR_RED;
				if(GetSeaTime() > 10 && abs(RollAngle) > ROLL_ANGLE_WARNING)
				{
					LogIt("Captain, we have to put our bow to the waves to decrease the rolling movement of the ship");

					rCharacter.Capsize.Warning  = ROLL_ANGLE_MORALE;
					rCharacter.Capsize.Time = GetSeaTime();
				}
			break;

			case ROLL_ANGLE_MORALE: // Second Warning
				IShipRoll.Log.color = COLOR_GREEN_LIGHT;
				if(abs(RollAngle) >  ROLL_ANGLE_MORALE ) IShipRoll.Log.color = COLOR_GREEN;
				if(abs(RollAngle) >  ROLL_ANGLE_GOODS  ) IShipRoll.Log.color = COLOR_YELLOW;
				if(abs(RollAngle) >  ROLL_ANGLE_DAMAGE ) IShipRoll.Log.color = COLOR_RED_LIGHT;
				if(abs(RollAngle) >  ROLL_ANGLE_CAPSIZE) IShipRoll.Log.color = COLOR_RED;
				if(GetSeaTime() - sti(rCharacter.Capsize.Time) > 10 && abs(RollAngle) > ROLL_ANGLE_MORALE)
				{
					RollDamageValue = sti(rCharacter.Ship.Crew.Morale) - 10;
					LogIt("Captain, the morale of the crew decreased from " + XI_ConvertString(GetMoraleName(rCharacter.Ship.Crew.Morale)) + " to " + XI_ConvertString(GetMoraleName(RollDamageValue)) + " because the ship's rolling is making them seasick");
					rCharacter.Ship.Crew.Morale = RollDamageValue; // Decrease morale one level
					if (sti(rCharacter.Ship.Crew.morale)<MORALE_MIN) rCharacter.Ship.Crew.morale=MORALE_MIN;

					rCharacter.Capsize.Warning  = ROLL_ANGLE_GOODS;
					rCharacter.Capsize.Time = GetSeaTime();
				}
			break;

			case ROLL_ANGLE_GOODS: // Third Warning
				IShipRoll.Log.color = COLOR_GREEN;
				if(abs(RollAngle) >  ROLL_ANGLE_GOODS  ) IShipRoll.Log.color = COLOR_YELLOW;
				if(abs(RollAngle) >  ROLL_ANGLE_DAMAGE ) IShipRoll.Log.color = COLOR_RED_LIGHT;
				if(abs(RollAngle) >  ROLL_ANGLE_CAPSIZE) IShipRoll.Log.color = COLOR_RED;
				if(GetSeaTime() - sti(rCharacter.Capsize.Time) > 10 && abs(RollAngle) > ROLL_ANGLE_GOODS)
				{
					for(i=GOODS_QUANTITY-1;i>=0;i--)
					{
						if(GetCargoGoods(rCharacter, i) <= 0) continue; // Don't dump cargo that isn't in the hold
						if (CheckAttribute(rCharacter, "quest.generate_trade_quest.iQuantityGoods"))
						{
							if ( i == sti(rCharacter.quest.generate_trade_quest.iTradeGoods) ) continue; // Don't dump quest cargo (not realistic, but less frustrating)
						}
						break;
					}
					if(GetCargoGoods(rCharacter, i) > 0)
					{
						RollDamageValue = 1 + makeint(0.1*GetCargoGoods(rCharacter, i));
						LogIt("Captain, the cargo has started shifting due to the rolling and " + RollDamageValue + " " + Goods[i].Name + " went overboard");
						RemoveCharacterGoods(rCharacter, i, RollDamageValue);
					}
					else // The cargo hold is empty
					{
						RollDamageValue = makeint(0.1*GetCrewQuantity(rCharacter));
						LogIt("*" + RollDamageValue + " crewmembers are heard yelling from inside the empty cargo hold*");
						RemoveCharacterCrew(rCharacter, RollDamageValue); // 10% crew damage
					}
					PlaySound("objects\abordage\abordage_loosing.wav"); // Armada: crew shout out
					rCharacter.Capsize.Warning  = ROLL_ANGLE_DAMAGE;
					rCharacter.Capsize.Time = GetSeaTime();
				}
			break;

			case ROLL_ANGLE_DAMAGE: // Fourth Warning
				IShipRoll.Log.color = COLOR_YELLOW;
				if(abs(RollAngle) >  ROLL_ANGLE_DAMAGE ) IShipRoll.Log.color = COLOR_RED_LIGHT;
				if(abs(RollAngle) >  ROLL_ANGLE_CAPSIZE) IShipRoll.Log.color = COLOR_RED;
				if(GetSeaTime() - sti(rCharacter.Capsize.Time) > 10 && abs(RollAngle) > ROLL_ANGLE_DAMAGE)
				{
					switch(rand(1))
					{
						case 0:
							RollDamageValue = makeint(0.1*sti(rCharacter.Ship.HP));
							PlaySound("objects\abordage\abordage_loosing.wav"); // Armada: crew shout out
							PlaySound("objects\shipcharge\ship_explosion.wav")
							CreateParticleSystemX("gunfire",    fX+4-rand(8), fY+4-rand(8), fZ+4-rand(8), 6.0, 4.0, 0.0, 0); // Armada: not yet working
							LogIt("Captain, shifting cargo did " + RollDamageValue + " damage to the hull");
							Ship_ApplyHullHitpoints(rCharacter, RollDamageValue, KILL_BY_TOUCH, -1); // 10% hull damage
						break;

						case 1:
							RollDamageValue = makeint(0.1*GetCrewQuantity(rCharacter));
							PlaySound("objects\abordage\abordage_loosing.wav"); // Armada: crew shout out
							for(i=0;i<RollDamageValue;i++)
							{
								if(rand(1) == 0)	CreateParticleSystem("flyers",      fX+4-rand(8), fY+4-rand(8), fZ+4-rand(8), 0.0, 0.0, 0.0, 0);
								else				CreateParticleSystem("flyers2",     fX+4-rand(8), fY+4-rand(8), fZ+4-rand(8), 0.0, 0.0, 0.0, 0);
							}
							AISeaGoods.ModelsPath = "LowCharacters";   //path to the crewmodels
							switch(rand(4)) // Put a crewmember in the sea behind the ship
							{
								case 0:
									Direct_AddGood(rCharacter, "Oil", "Lo_Man",  100.0, RollDamageValue, 800, Degree2Radian(180.0));
								break;
								case 1:
									Direct_AddGood(rCharacter, "Oil", "Lo_Man2", 100.0, RollDamageValue, 800, Degree2Radian(180.0));
								break;
								case 2:
									Direct_AddGood(rCharacter, "Oil", "Lo_Man3", 100.0, RollDamageValue, 800, Degree2Radian(180.0));
								break;
								case 3:
									Direct_AddGood(rCharacter, "Oil", "Lo_Man4", 100.0, RollDamageValue, 800, Degree2Radian(180.0));
								break;
								case 4:
									Direct_AddGood(rCharacter, "Oil", "Lo_Man5", 100.0, RollDamageValue, 800, Degree2Radian(180.0));
								break;
							}
							AISeaGoods.ModelsPath = "SwimGoods";   //reset path to the salvagemodels
							LogIt("Captain, that last violent roll washed " + RollDamageValue + " crewmembers overboard");
							RemoveCharacterCrew(rCharacter, RollDamageValue); // 10% crew damage
						break;
					}
					rCharacter.Capsize.Warning  = ROLL_ANGLE_CAPSIZE;
					rCharacter.Capsize.Time = GetSeaTime();
				}
			break;

			case ROLL_ANGLE_CAPSIZE: // Fifth Warning
				IShipRoll.Log.color = COLOR_RED_LIGHT;
				if(abs(RollAngle) >  ROLL_ANGLE_CAPSIZE) IShipRoll.Log.color = COLOR_RED;
				if(GetSeaTime() - sti(rCharacter.Capsize.Time) > 10 && abs(RollAngle) > ROLL_ANGLE_CAPSIZE)
				{
					if(RollAngle > 0)	LogIt("Captain, we're capsizing to starboard... ABANDON SHIP!");
					else				LogIt("Captain, we're capsizing to port... ABANDON SHIP!");
					PlaySound("objects\shipcharge\_Abandon0.wav");
					PlaySound("objects\abordage\abordage_loosing.wav");
					Playsound("objects\shipcharge\mast_fall3.wav"); // Armada: ship capsizing- uses mast falling sound
					rCharacter.Capsize.Angle = RollAngle;
					ShipDead(sti(rCharacter.Index), KILL_BY_OWNER, sti(rCharacter.Index));
				}
			break;
		}
		SendMessage(&IShipRoll, "lll", LOG_AND_ACTIONS_INIT, false, true);
	}
	else sshiproll = "";
	SendMessage(&IShipRoll, "lls", LOG_ADD_STRING, true, sshiproll);
}
// Capsizing <--

void ReloadToTexturedModel(string model, string texture)
{
	string locid = "";
	ref loc;
	for(int i = 0; i < nLocationsNum; i++)
	{
		loc = &Locations[i];
		if(!CheckAttribute(loc, "filespath.models")) continue;
		if(texture == "")
		{
			if(CheckAttribute(loc, "filespath.textures")) continue;
			if(loc.filespath.models == "locations\" + model)
			{
				locid = loc.id;
				break;
			}
		}
		else
		{
			if(!CheckAttribute(loc, "filespath.textures")) continue;
			if(loc.filespath.models == "locations\" + model && loc.filespath.textures == "locations\" + texture)
			{
				locid = loc.id;
				break;
			}
		}
	}
	if(texture == "") texture = "DEFAULT";
	if(locid != "")
	{
		DoQuestReloadToLocation(locid, "reload", loc.reload.l1.name, "");
		if(loc.type == "port" || loc.type == "seashore") SetCharacterShipLocation(GetMainCharacter(), locid);
	}
	else LogIt("No location with model folder = " + model + " and texture folder = " + texture);
}

void CycleThroughTexturedModels(string model)
{
	ref pchar = GetMainCharacter();
	if(!CheckAttribute(pchar, "modeltexturefolder")) pchar.modeltexturefolder = "";
	ReloadToTexturedModel(model, pchar.modeltexturefolder);
	switch(pchar.modeltexturefolder)
	{
		case "":			pchar.modeltexturefolder = "decks";		break;
		case "decks":		pchar.modeltexturefolder = "ENGLAND";	break;
		case "ENGLAND":		pchar.modeltexturefolder = "FRANCE";	break;
		case "FRANCE":		pchar.modeltexturefolder = "HOLLAND";	break;
		case "HOLLAND":		pchar.modeltexturefolder = "NATIVES";	break;
		case "NATIVES":		pchar.modeltexturefolder = "SPAIN";		break;
		case "SPAIN":		pchar.modeltexturefolder = "AMERICA";	break;
		case "AMERICA":		pchar.modeltexturefolder = "";			break;
	}
}

// stljeffbb Jan 15 2012 -->
void InitOpenSeaMod()
{
	ref PChar = GetMainCharacter();
	if(iRealismMode>1 || OPEN_SEA_MOD)
	{
		DIRECTENCOUNTERCHANCE =								22;		// chance in percent that an encounter fleet appears every hour
		DIRECTENCOUNTERDISTANCE =							2250;	// distance from player at which random ships appear 
		ISLANDSWITCHDISTANCE =								30000.0;// for islandcell mode only: distance from island at which transfer to neighbour island starts
		ENCOUNTERBREAK =									6.0;	// LDH - Changed to float, number is hours per encounter, directsail is called every 5 minutes occasionally
		// so you can let the clock run faster (by increasing #define TIMESCALAR_SEA in InternalSettings.h ), meaning longer voyagetimes, without getting too many encounters.

		TIMESCALAR_SEA =									15;		// INT - how many seconds of gametime one second of realtime is at sea
		MAX_WBALLAST =										10;		// INT - how far the weighting will swing in favor of current trend.. use positive integer between 0 and 50 - 0 is no swing - 50 is major swing.. this is for Windspeed
		MAX_RBALLAST =										10;		// ^^DITTO for rain
		MAX_FBALLAST =										10;		// ^^DITTO for fog
		MAX_ABALLAST =										10.0;	// FLOAT - ^^DITTO for wind angle

		MAX_WINDCHANGE =									 3;		// INT - How much the wind CAN change in one hour - use positive integer between 0 and 20
		MAX_FOGCHANGE =										 3;		// INT - ^^DITTO for fog
		MAX_RAINCHANGE =									 3;		// INT - ^^DITTO for rain

		COASTRAIDER_CHANCE = 								0.01;	// FLOAT - Generates local ships in ports and around the islands. Some are local merchants, others pirates.
																	// 0.0 : Stock PotC, no local ships at all
																	// 0.1 - 0.9 : The higher that value the more pirates instead of merchants appear
		NAVYRAIDER_CHANCE = 								2.0; 	// FLOAT - Ditto, but chance that raider is a foreign warship. Chance for that is coastraider_chance * navyraider_chance
		MIN_ENEMY_DISTANCE_TO_DISABLE_MAP_ENTER =			100.0;	// FLOAT - original value is 500 - Petros: reset to 500.0 to prevent trouble
		MIN_ENEMY_DISTANCE_TO_DISABLE_ENTER_2_LOCATION =	100.0;	// FLOAT - original value is 500
		RANGE_TO_ENEMY =									3500;	// INT - in feet/yards/whatever unit the game uses.

		WDM_MAP_TO_SEA_SCALE =								60;		// orig 19.607843 for this and next line
		WDM_MAP_TO_SEA_ENCOUNTERS_SCALE =					60;		// was 60 in build, 10.0 in stock. NK 05-04-30

		if(CheckCharacterItem(PChar,"map"))
		{
			TakeItemFromCharacter(PChar, "map");
			GiveItem2Character(PChar, "map_scaled");
		}
	}
	else
	{
		DIRECTENCOUNTERCHANCE =								50;		// chance in percent that an encounter fleet appears every hour
		DIRECTENCOUNTERDISTANCE =							1000;	// distance from player at which random ships appear 
		ISLANDSWITCHDISTANCE =								5000.0; // for islandcell mode only: distance from island at which transfer to neighbour island starts
		ENCOUNTERBREAK =									1.0;	// LDH - Changed to float, number is hours per encounter, directsail is called every 5 minutes occasionally
		// so you can let the clock run faster (by increasing #define TIMESCALAR_SEA in InternalSettings.h ), meaning longer voyagetimes, without getting too many encounters.

		TIMESCALAR_SEA =									 5;		// INT - how many seconds of gametime one second of realtime is at sea
		MAX_WBALLAST =										25;		// INT - how far the weighting will swing in favor of current trend.. use positive integer between 0 and 50 - 0 is no swing - 50 is major swing.. this is for Windspeed
		MAX_RBALLAST =										25;		// ^^DITTO for rain
		MAX_FBALLAST =										25;		// ^^DITTO for fog
		MAX_ABALLAST =										25.0;	// FLOAT - ^^DITTO for wind angle

		MAX_WINDCHANGE =									5;		// INT - How much the wind CAN change in one hour - use positive integer between 0 and 20
		MAX_FOGCHANGE =										5;		// INT - ^^DITTO for fog
		MAX_RAINCHANGE =									5;		// INT - ^^DITTO for rain

		COASTRAIDER_CHANCE = 								0.2;	// FLOAT - Generates local ships in ports and around the islands. Some are local merchants, others pirates.
																	// 0.0 : Stock PotC, no local ships at all
																	// 0.1 - 0.9 : The higher that value the more pirates instead of merchants appear
		NAVYRAIDER_CHANCE = 								0.4; 	// FLOAT - Ditto, but chance that raider is a foreign warship. Chance for that is coastraider_chance * navyraider_chance
		MIN_ENEMY_DISTANCE_TO_DISABLE_MAP_ENTER =			500.0;	// FLOAT - original value is 500 - Petros: reset to 500.0 to prevent trouble
		MIN_ENEMY_DISTANCE_TO_DISABLE_ENTER_2_LOCATION =	500.0;	// FLOAT - original value is 500
		RANGE_TO_ENEMY =									3000;	// INT - in feet/yards/whatever unit the game uses.

		WDM_MAP_TO_SEA_SCALE =							19.607843;	// orig 19.607843 for this and next line
		WDM_MAP_TO_SEA_ENCOUNTERS_SCALE =				19.607843;	// was 60 in build, 10.0 in stock. NK 05-04-30

		if(CheckCharacterItem(PChar,"map_scaled"))
		{
			TakeItemFromCharacter(PChar, "map_scaled");
			GiveItem2Character(PChar, "map");
		}
	}
}
// stljeffbb Jan 15 2012 <--

void CreateColombia()
{
	if(FindIsland("Colombia")!=-1) { ColombiaWorldMapInit(); return; }
	DirectsailAddBattle_Rocks();
	object	locator;
	CreateEntity(&locator,"locator");

	Islands[ISLANDS_QUANTITY].reload_enable = true;

	Islands[ISLANDS_QUANTITY].id = "Colombia";
	Islands[ISLANDS_QUANTITY].model = "IslaMuelle";
	Islands[ISLANDS_QUANTITY].filespath.models = "islands\IslaMuelle";
	Islands[ISLANDS_QUANTITY].refl_model = "IslaMuelle_refl";
	Islands[ISLANDS_QUANTITY].locators = "IslaMuelle_locators";
	Islands[ISLANDS_QUANTITY].visible = true;
	Islands[ISLANDS_QUANTITY].Enc_enable = false;
	Islands[ISLANDS_QUANTITY].skipCR = true; // KK
	Islands[ISLANDS_QUANTITY].smuggling_nation = SPAIN;
	Islands[ISLANDS_QUANTITY].towns.quantity = 1;//Cities - way for adding new model into the WorldMap

	Islands[ISLANDS_QUANTITY].reload.l1.old.label = "Cartagena Port";
	Islands[ISLANDS_QUANTITY].reload.l1.label = TranslateString("","Cartagena Port");
	Islands[ISLANDS_QUANTITY].reload.l1.name = "reload_1";
	Islands[ISLANDS_QUANTITY].reload.l1.go = "Cartagena_Port";
	Islands[ISLANDS_QUANTITY].reload.l1.emerge = "reload3";
	Islands[ISLANDS_QUANTITY].reload.l1.ships.l0.ay = 2.5;
	Islands[ISLANDS_QUANTITY].reload.l1.radius = 200.0;
	Islands[ISLANDS_QUANTITY].reload.l1.pic = 0;
	Islands[ISLANDS_QUANTITY].reload.l1.tex = "t1";
	Islands[ISLANDS_QUANTITY].reload.l1.goto_enable = true;

	Islands[ISLANDS_QUANTITY].InterfaceTextures.t1 = "battle_interface\moor_4.tga";
	Islands[ISLANDS_QUANTITY].InterfaceTextures.t1.h = 4;
	Islands[ISLANDS_QUANTITY].InterfaceTextures.t1.v = 1;

	Islands[ISLANDS_QUANTITY].reload.l4.label = "Cartagena Fort"; // KK
	Islands[ISLANDS_QUANTITY].reload.l4.name = "reload_fort1";
	Islands[ISLANDS_QUANTITY].reload.l4.fort.model = "SanFelipe";
	Islands[ISLANDS_QUANTITY].reload.l4.fort.locators = "IslaMuelle_fort1_locators";
	Islands[ISLANDS_QUANTITY].reload.l4.pic = 1;
	Islands[ISLANDS_QUANTITY].reload.l4.tex = "t1";

	SendMessage(&locator,"le",LM_LOCATE_I,&Islands[ISLANDS_QUANTITY]);
	ISLANDS_QUANTITY = ISLANDS_QUANTITY+1;

	DeleteClass(&locator);
	nLocationsNum = InitColombia(nLocationsNum);
	ColombiaWorldMapInit();
}

int InitColombia(int n)
{
	if(GetLocationIndex("Residence_Cartagena")!=-1) return n;
	// -------------------------------------------------
	Locations[n].id = "Residence_Cartagena";
	locations[n].id.label = "Residence.";
	locations[n].worldmap = "Colombia";
	Locations[n].image = "Town_Cartagena_Residence.tga";
	Locations[n].vcskip = true;
	//Town sack
	Locations[n].townsack = "Cartagena";

	//Sound
	locations[n].type = "town";
	locations[n].soundskip = true;
	//Models
	Locations[n].filespath.models = "locations\Town_Cartagena\Residence";
	Locations[n].models.always.locators = "Townhall_l";

	//Environment
	Locations[n].environment.weather = "true";
	Locations[n].environment.sea = "true";

	//Always
	Locations[n].models.always.grassPatch = "Townhall_g";
	Locations[n].models.always.l1 = "Townhall";
	Locations[n].models.always.l1.foam = "1";
	Locations[n].models.always.l2 = "Townhall_sb";
	Locations[n].models.always.l2.foam = "1";
	Locations[n].models.always.pedra = "pierre";
	Locations[n].models.always.pedra.locator.group = "goto";
	Locations[n].models.always.pedra.locator.name = "goto25";
	Locations[n].models.always.pedrab = "pierre2";
	Locations[n].models.always.pedrab.locator.group = "goto";
	Locations[n].models.always.pedrab.locator.name = "goto26";
	Locations[n].models.always.pedrac = "pierre3";
	Locations[n].models.always.pedrac.locator.group = "goto";
	Locations[n].models.always.pedrac.locator.name = "goto27";
	//Day
	Locations[n].models.day.charactersPatch = "Townhall_pd";
	//Night
	Locations[n].models.night.charactersPatch = "Townhall_pn";

	//Reload map
	Locations[n].reload.l5.go = "Cartagena_townhall";
	Locations[n].reload.l5.emerge = "reload1";
	Locations[n].reload.l5.name = "reload3_back";
	Locations[n].reload.l5.autoreload = "0";
	Locations[n].reload.l5.label = "Residence.";
	Locations[n].reload.l5.close_for_night = 1;
	if(iRealismMode>0) Locations[n].reload.l5.goto_disable = 1; // Screwface: Disable Go-To location

	Locations[n].reload.l10.go = "Cartagena_town_02";
	Locations[n].reload.l10.emerge = "Falaise_de_fleur_location_02_01";
	Locations[n].reload.l10.label = "Town.";
	Locations[n].reload.l10.name = "gate";
	Locations[n].reload.l10.autoreload = "0";

	Build_at("Residence_Cartagena", "fontain", "", -3.4512, 2.02, 16.102, 1.5, "Building");
	Build_at("Residence_Cartagena", "fontain", "", -3.4512, 2.02, -4.0, 1.5, "Building");
	Build_at("Residence_Cartagena", "farm", "", -11.864, 7.01, -40.385, 1.7, "Building");
	Build_at("Residence_Cartagena", "windmill", "", -18.434, 12, -55.73, 0.0, "Building");
	Build_at("Residence_Cartagena", "hedgerow", "", 30.087, 3.01, -32.243, 2.0, "Building");
	Build_at("Residence_Cartagena", "hedgerow", "", 1.2461, 2.01, -17.081, 2.0, "Building");
	Build_at("Residence_Cartagena", "hedgerow2", "", -25.873, 2.01, 23.558, 1.5, "Building");
	Build_at("Residence_Cartagena", "hedgerow2", "", 30.24, 2.01, 32.578, 0.0, "Building");

	Locations[n].island = "Colombia";
	n = n + 1;

	if(GetLocationIndex("Cartagena_Port")!=-1) return n;
// -----------------------------------------------------------------
	Locations[n].filespath.models = "locations\Town_Cartagena\Port";
	Locations[n].filespath.textures = "locations\SPAIN";
	Locations[n].image = "Town_Cartagena_Port.tga";

	Locations[n].id = "Cartagena_port";
	LAi_LocationFantomsGen(&locations[n], true);
	locations[n].id.label = "#stown_name# port."; // KK
	locations[n].worldmap = "Colombia";

	//Town sack
	Locations[n].townsack = "Cartagena";

	//Sound
	locations[n].type = "port";
//	locations[n].fastreload = "Cartagena";
	//Models
	//Always
	Locations[n].models.always.SanFelipe = "SanFelipe";
	Locations[n].models.always.locators = "CartPort_l";
	Locations[n].models.always.grassPatch = "CartPort_g";
	Locations[n].models.always.l1 = "CartPort";
	Locations[n].models.always.l1.foam = "1";
	Locations[n].models.always.l2 = "CartPort_sb";
	Locations[n].models.always.l2.foam = "1";
	//Day
//	Locations[n].models.day.rinok = "CartPort_e1";
	Locations[n].models.day.fonar = "CartPort_fd";
	Locations[n].models.day.charactersPatch = "CartPort_pd";
	//Night
	Locations[n].models.night.fonar = "CartPort_fn";
	Locations[n].models.night.charactersPatch = "CartPort_pn";
	//Environment
	Locations[n].environment.weather = "true";
	Locations[n].environment.sea = "true";
	//Reload map

	Locations[n].reload.l1.name = "reload2";
	Locations[n].reload.l1.go = "Cartagena_town_01";
	Locations[n].reload.l1.emerge = "reload_from_port";
	Locations[n].reload.l1.autoreload = "0";
	Locations[n].reload.l1.label = "Town.";
	Locations[n].locators_radius.reload.reload2 = 2.0;


	Locations[n].reload.l2.name = "reload1";
	Locations[n].reload.l2.go = "Colombia";
	Locations[n].reload.l2.emerge = "reload_1";
	Locations[n].reload.l2.autoreload = "0";
	if (VISIT_DECK == 1)
		Locations[n].reload.l2.label = "Ship.";
	else
		Locations[n].reload.l2.label = "Sea.";
	Locations[n].locators_radius.reload.reload1 = 2.0;

	Locations[n].reload.l4.name = "reload1_back";
	Locations[n].reload.l4.go = "Colombia";
	Locations[n].reload.l4.emerge = "reload_1";
	Locations[n].reload.l4.autoreload = "0";
	if (VISIT_DECK == 1)
		Locations[n].reload.l4.label = "Ship.";
	else
		Locations[n].reload.l4.label = "Sea.";
	Locations[n].locators_radius.reload.reload1_back = 2.0;

	Locations[n].reload.l3.name = "reload3";
	Locations[n].reload.l3.go = "Colombia";
	Locations[n].reload.l3.emerge = "reload_1";
	Locations[n].reload.l3.autoreload = "0";
	if (VISIT_DECK == 1)
		Locations[n].reload.l3.label = "Ship.";
	else
		Locations[n].reload.l3.label = "Sea.";

	Locations[n].locators_radius.reload.reload3 = 2.0;

	Locations[n].reload.l5.name = "reload3_back";
	Locations[n].reload.l5.go = "Colombia";
	Locations[n].reload.l5.emerge = "reload_1";
	Locations[n].reload.l5.autoreload = "0";
	if (VISIT_DECK == 1)
		Locations[n].reload.l5.label = "Ship.";
	else
		Locations[n].reload.l5.label = "Sea.";

	Locations[n].locators_radius.reload.reload3_back = 2.0;

	Locations[n].island = "Colombia"; // NK 04-08-29
	n = n + 1;
	
	if(GetLocationIndex("Cartagena_PortB")!=-1) return n;
// -----------------------------------------------------------------
	Locations[n].filespath.models = "locations\Town_Cartagena\Port";
	Locations[n].filespath.textures = "locations\SPAIN";
	Locations[n].image = "Town_Cartagena_Port.tga";

	Locations[n].id = "Cartagena_PortB";//location only for climbing ship
	locations[n].id.label = "Cartagena port."; // KK
	locations[n].worldmap = "Colombia";
	Locations[n].vcskip = true;
	
	//Town sack
	Locations[n].townsack = "Cartagena";
	//Sound
	locations[n].type = "port";
	//Models
	//Always
	Locations[n].models.always.SanFelipe = "SanFelipe";
	Locations[n].models.always.locators = "CartPortB_l";
	Locations[n].models.always.grassPatch = "CartPort_g";
	Locations[n].models.always.l1 = "CartPort";
	Locations[n].models.always.l1.foam = "1";
	Locations[n].models.always.l2 = "CartPort_sb";
	Locations[n].models.always.l2.foam = "1";
	//Day
//	Locations[n].models.day.rinok = "CartPort_e1";
	Locations[n].models.day.fonar = "CartPort_fd";
	Locations[n].models.day.charactersPatch = "CartPortB_pd";
	//Night
	Locations[n].models.night.fonar = "CartPort_fn";
	Locations[n].models.night.charactersPatch = "CartPortB_pn";
	//Environment
	Locations[n].environment.weather = "true";
	Locations[n].environment.sea = "true";
	//Reload map

	Locations[n].reload.l1.name = "reload2";
	Locations[n].reload.l1.go = "";
	Locations[n].reload.l1.emerge = "";
	Locations[n].reload.l1.autoreload = "0";
	Locations[n].reload.l1.label = "Ship.";
	Locations[n].locators_radius.reload.reload2 = 2.0;


	Locations[n].reload.l2.name = "reload1";
	Locations[n].reload.l2.go = "";
	Locations[n].reload.l2.emerge = "";
	Locations[n].reload.l2.autoreload = "0";
	Locations[n].reload.l2.label = "Sea.";
	Locations[n].locators_radius.reload.reload1 = 2.0;

	Locations[n].island = "Colombia"; // NK 04-08-29
	n = n + 1;	

	if(GetLocationIndex("Cartagena_town_01")!=-1) return n;
	// Cartagena_town_01 -------------------------------------------------
	Locations[n].filespath.models = "locations\Town_Redmond\Town_01";
	Locations[n].filespath.textures = "locations\SPAIN";
	Locations[n].image = "Town_Redmond_Town_01_Cartagena.tga";

	Locations[n].id = "Cartagena_town_01";
	locations[n].id.label = "Cartagena town";
	locations[n].worldmap = "Colombia";

	//Town sack
	Locations[n].townsack = "Cartagena";
	//Sound
	locations[n].type = "town";
	LAi_LocationFantomsGen(&locations[n], true);
	//Models
	//Always
	Locations[n].models.always.L1 = "Red01";
	Locations[n].models.always.locators = "Red01_l_xb";
	Locations[n].models.always.grassPatch = "Red01_g";
	Locations[n].models.always.palace = "Palais";
	Locations[n].models.always.palace.locator.group = "goto";
	Locations[n].models.always.palace.locator.name = "goto60";
	Locations[n].models.always.church = "Church1";
	Locations[n].models.always.church.locator.group = "goto";
	Locations[n].models.always.church.locator.name = "goto61";
	//River
	Locations[n].models.always.dno = "Red01_rb01";
	Locations[n].models.always.dno.level = 95;
	Locations[n].models.always.dno.uvslide.u1 = -0.12;
	Locations[n].models.always.dno.uvslide.v1 = -0.03;
	Locations[n].models.always.dno.tech = "LocationRiverFloor";
	Locations[n].models.always.mirrow = "Red01_re01";
	Locations[n].models.always.mirrow.level = 96;
	Locations[n].models.always.dnoBlend = "Red01_rb01";
	Locations[n].models.always.dnoBlend.level = 97;
	Locations[n].models.always.dnoBlend.uvslide.u1 = -0.1;
	Locations[n].models.always.dnoBlend.uvslide.v1 = 0.04;
	Locations[n].models.always.dnoBlend.tech = "LocationRiverFloorBlend";
	Locations[n].models.always.river = "Red01_rt01";
	Locations[n].models.always.river.level = 98;
	Locations[n].models.always.river.uvslide.v0 = -0.1;
	Locations[n].models.always.river.uvslide.u1 = 0.15;
	Locations[n].models.always.river.tech = "LocationRiver";

	//Day
	Locations[n].models.day.fonar = "Red01_fd";
	Locations[n].models.day.charactersPatch = "Red01_p";
	Locations[n].models.day.rinok = "Red01_e01";
	//Night
	Locations[n].models.night.fonar = "Red01_fn";
	Locations[n].models.night.charactersPatch = "Red01_p";
	//Environment
	Locations[n].environment.weather = "true";
	Locations[n].environment.sea = "false";
	//Reload map
	Locations[n].reload.l1.name = "reload_1_4";
	Locations[n].reload.l1.go = "Cartagena_town_02";
	Locations[n].reload.l1.emerge = "Falaise_de_fleur_location_02_03";
	Locations[n].reload.l1.autoreload = "1";
	Locations[n].reload.l1.label = "Town.";
	Locations[n].locators_radius.reload.reload_1_4 = 2.0;

	Locations[n].reload.l2.name = "reload_1_4_back";
	Locations[n].reload.l2.go = "Cartagena_town_02";
	Locations[n].reload.l2.emerge = "Falaise_de_fleur_location_02_03";
	Locations[n].reload.l2.autoreload = "1";
	Locations[n].reload.l2.label = "Town.";
	Locations[n].locators_radius.reload.reload_1_4_back = 2.0;

	Locations[n].reload.l5.name = "reload_from_port";
	Locations[n].reload.l5.go = "Cartagena_port";
	Locations[n].reload.l5.emerge = "reload2";
	Locations[n].reload.l5.autoreload = "0";
	Locations[n].reload.l5.label = "Sea port.";

	Locations[n].reload.l6.name = "reload_2_3";
	Locations[n].reload.l6.go = "Palace";
	Locations[n].reload.l6.emerge = "reload1";
	Locations[n].reload.l6.autoreload = "0";
	Locations[n].reload.l6.label = "Palace";
	Locations[n].locators_radius.reload.reload_2_3 = 2.0;
	
	Locations[n].reload.l7.name = "reload_2_4_back";
	Locations[n].reload.l7.go = "Cartagena_Center";
	Locations[n].reload.l7.emerge = "reload1";
	Locations[n].reload.l7.autoreload = "1";
	Locations[n].reload.l7.label = "Cartagena town.";
	Locations[n].locators_radius.reload.reload_2_4_back = 2.0;

	Locations[n].reload.l8.name = "reload_2_4";
	Locations[n].reload.l8.go = "Cartagena_Center";
	Locations[n].reload.l8.emerge = "reload1";
	Locations[n].reload.l8.autoreload = "1";
	Locations[n].reload.l8.label = "Cartagena town.";
	Locations[n].locators_radius.reload.reload_2_4 = 2.0;	

	Locations[n].island = "Colombia"; // NK 04-08-29
	n = n + 1;

	if(GetLocationIndex("Cartagena_town_02")!=-1) return n;
	// Cartagena_town_02 -------------------------------------------------
	Locations[n].id = "Cartagena_town_02";
	locations[n].id.label = "Cartagena town.";
	locations[n].worldmap = "Colombia";
	Locations[n].image = "Town_FalaiseDeFleur_town_01_Spain.tga";

	//Town sack
	Locations[n].townsack = "Cartagena";

	//Sound
	locations[n].type = "town";
	LAi_LocationFantomsGen(&locations[n], true);
	//Models
	//Always
	Locations[n].filespath.models = "locations\Town_FalaiseDeFleur\town_01";
	Locations[n].filespath.textures = "locations\SPAIN";
	Locations[n].models.always.city = "FF01";
	Locations[n].models.always.locators = "FF01_l";
	Locations[n].models.always.grassPatch = "FF01_g";
	Locations[n].models.always.l1 = "plan_1";
	Locations[n].models.always.l1.level = 9;
	Locations[n].models.always.l1.tech = "LocationModelBlend";
	Locations[n].models.always.l2 = "plan_2";
	Locations[n].models.always.l2.level = 8;
	Locations[n].models.always.l2.tech = "LocationModelBlend";
	Locations[n].models.always.l3 = "plan_3";
	Locations[n].models.always.l3.level = 7;
	Locations[n].models.always.l3.tech = "LocationModelBlend";

	//Day
	Locations[n].models.day.fonar = "FF01_fd";
	Locations[n].models.day.charactersPatch = "FF01_p";
	//Night
	Locations[n].models.night.fonar = "FF01_fn";
	Locations[n].models.night.charactersPatch = "FF01_p";
	//Environment
	Locations[n].environment.weather = "true";
	Locations[n].environment.sea = "false";
	//Reload map
	Locations[n].reload.l1.name = "Falaise_de_fleur_location_02_01";
	Locations[n].reload.l1.go = "Residence_Cartagena";
	Locations[n].reload.l1.emerge = "gate";
	Locations[n].reload.l1.autoreload = "0";
	Locations[n].reload.l1.label = "Townhall";

	Locations[n].reload.l2.name = "Falaise_de_fleur_location_02_03";
	Locations[n].reload.l2.go = "Cartagena_town_01";
	Locations[n].reload.l2.emerge = "reload_1_4";
	Locations[n].reload.l2.autoreload = "0";
	Locations[n].reload.l2.label = "Town.";

	Locations[n].reload.l3.name = "Falaise_de_fleur_location_02_perechod";
	Locations[n].reload.l3.go = "cloister_exit";
	Locations[n].reload.l3.emerge = "reload1";
	Locations[n].reload.l3.autoreload = "0";
	Locations[n].reload.l3.label = "cloister.";
/*
	Locations[n].reload.l4.name = "locator21";
	Locations[n].reload.l4.go = "house_of_Elzire_Ayarai";
	Locations[n].reload.l4.emerge = "reload1";
	Locations[n].reload.l4.autoreload = "0";
	Locations[n].reload.l4.label = "House.";

	Locations[n].reload.l5.name = "locator20";
	Locations[n].reload.l5.go = "HouseInsideR20";
	Locations[n].reload.l5.emerge = "reload1";
	Locations[n].reload.l5.autoreload = "0";
	Locations[n].reload.l5.label = "House.";
*/
	Locations[n].island = "Colombia"; // NK 04-08-29
	n = n + 1;

	if(GetLocationIndex("Cartagena_Fort")!=-1) return n;
// -----------------------------------------------------------------
	Locations[n].filespath.models = "locations\Town_Cartagena\Port";
	Locations[n].filespath.textures = "locations\SPAIN";
	Locations[n].image = "Town_Cartagena_Fort.tga";

	Locations[n].id = "Cartagena_fort";
	locations[n].id.label = "Cartagena fort."; // KK
	locations[n].worldmap = "Colombia";

	Locations[n].vcskip = true;

	//Town sack
	Locations[n].townsack = "Cartagena";

	//Sound
	locations[n].type = "port";
	//Models
	//Always
	Locations[n].models.always.SanFelipe = "SanFelipe";
	Locations[n].models.always.locators = "Cartfort_l";
	Locations[n].models.always.grassPatch = "CartPort_g";
	Locations[n].models.always.l1 = "CartPort";
	Locations[n].models.always.l1.foam = "1";
	Locations[n].models.always.l2 = "CartPort_sb";
	Locations[n].models.always.l2.foam = "1";
	//Day
	Locations[n].models.day.rinok = "CartPort_e1";
	Locations[n].models.day.fonar = "CartPort_fd";
	Locations[n].models.day.charactersPatch = "Cartfort_pd";
	//Night
	Locations[n].models.night.fonar = "CartPort_fn";
	Locations[n].models.night.charactersPatch = "Cartfort_pn";
	//Environment
	Locations[n].environment.weather = "true";
	Locations[n].environment.sea = "true";
	//Reload map

	Build_at("Cartagena_Fort", "cannonl", "", -102.89, 23.968, -107.18, 2.6, "");
	Build_at("Cartagena_Fort", "cannonl", "", -71.131, 21.667, -189.49, 2.7, "");
	Build_at("Cartagena_Fort", "cannonl", "", -80.127, 21.923, -170.66, 2.7, "");		
	Build_at("Cartagena_Fort", "cannonl", "", -184.61, 10.428, -129.41, 3.1, "");
	Build_at("Cartagena_Fort", "cannonl", "", -181.84, 15.917, -48.384, 2.8, "");	
	
	Locations[n].island = "Colombia"; // NK 04-08-29
	n = n + 1;

	if(GetLocationIndex("cloister_inside")!=-1) return n;
	// -------------------------------------------------

	Locations[n].filespath.models = "locations\Town_Cartagena\Cloister_exit";
	Locations[n].image = "Town_Cartagena_Cloister_Inside.tga";

	Locations[n].vcskip = true;

	Locations[n].id = "Cloister_inside";
	locations[n].id.label = "cloister inside";
	//Town sack
	Locations[n].townsack = "Cartagena";
	//Sound
	locations[n].type = "town";
	//Models
	//Always
	Locations[n].models.always.locators = "cloister_l";
	Locations[n].models.always.town = "cloister_exit";

	//Day
	Locations[n].models.day.charactersPatch = "cloister_p";
	//Night
	Locations[n].models.night.charactersPatch = "cloister_p";
	//Environment
	Locations[n].environment.weather = "true";
	Locations[n].environment.sea = "false";

	//Reload map
	Locations[n].reload.l1.name = "reload1";
	Locations[n].reload.l1.go = "cloister_exit";
	Locations[n].reload.l1.emerge = "reload2";
	Locations[n].reload.l1.autoreload = "0";
	Locations[n].reload.l1.label = "Cloister.";

	Locations[n].island = "Colombia"; // NK 04-08-29

	Build_at("cloister_inside", "jungle2", "", -3.4676, 0, 26.249, 0.0, "Building");
	Build_at("cloister_inside", "fontain2", "", 3.1457, 0, 0.55425, -1.5, "Building");

	n = n + 1;

	if(GetLocationIndex("cloister_exit")!=-1) return n;
	// -------------------------------------------------

	Locations[n].filespath.models = "locations\Town_Cartagena\Cloister_exit";
	Locations[n].image = "Town_Cartagena_Cloister_Outside.tga";

	Locations[n].vcskip = true;

	Locations[n].id = "cloister_exit";
	locations[n].id.label = "cloister exit";
	//Town sack
	Locations[n].townsack = "Cartagena";
	//Sound
	locations[n].type = "town";
	//Models
	//Always
	Locations[n].models.always.locators = "cloister_exit_l";
	Locations[n].models.always.town = "cloister_exit";

	//Day
	Locations[n].models.day.charactersPatch = "cloister_exit_p";
	//Night
	Locations[n].models.night.charactersPatch = "cloister_exit_p";
	//Environment
	Locations[n].environment.weather = "true";
	Locations[n].environment.sea = "false";
	//Reload map
	Locations[n].reload.l1.name = "reload1";
	Locations[n].reload.l1.go = "Cartagena_town_02";
	Locations[n].reload.l1.emerge = "Falaise_de_fleur_location_02_perechod";
	Locations[n].reload.l1.autoreload = "0";
	Locations[n].reload.l1.label = "Town.";

	Locations[n].reload.l2.name = "reload2";
	Locations[n].reload.l2.go = "Cloister_inside";
	Locations[n].reload.l2.emerge = "reload1";
	Locations[n].reload.l2.autoreload = "0";
	Locations[n].reload.l2.label = "Cloister.";

	Locations[n].island = "Colombia"; // NK 04-08-29

	Build_at("cloister_exit", "jungle2", "", -3.4676, 0, 26.249, 0.0, "Building");
	Build_at("cloister_exit", "fontain2", "", 3.1457, 0, 0.55425, -1.5, "Building");

	n = n + 1;

	if(GetLocationIndex("Palace")!=-1) return n;
	// -------------------------------------------------

	Locations[n].filespath.models = "locations\Town_Cartagena\Palace";
	Locations[n].image = "Town_Cartagena_Palace.tga";

//	Locations[n].vcskip = true;

	Locations[n].id = "Palace";
	locations[n].id.label = "Palace square";
	//Town sack
	Locations[n].townsack = "Cartagena";
	//Sound
	locations[n].type = "town";
	//Models
	Locations[n].models.always.mercado1 = "market";
	Locations[n].models.always.mercado1.locator.group = "goto";
	Locations[n].models.always.mercado1.locator.name = "goto1";
	//Always
	Locations[n].models.always.locators = "Palais_l";
	Locations[n].models.always.town = "Palais";

	//Day
	Locations[n].models.day.charactersPatch = "Palais_p";
	//Night
	Locations[n].models.night.charactersPatch = "Palais_p";
	//Environment
	Locations[n].environment.weather = "true";
	Locations[n].environment.sea = "false";
	//Reload map
	Locations[n].reload.l1.name = "reload1";
	Locations[n].reload.l1.go = "Cartagena_town_01";
	Locations[n].reload.l1.emerge = "reload_2_3";
	Locations[n].reload.l1.autoreload = "0";
	Locations[n].reload.l1.label = "Town.";

	Locations[n].reload.l2.name = "reload2";
	Locations[n].reload.l2.go = "Palace_Residence";
	Locations[n].reload.l2.emerge = "reload1";
	Locations[n].reload.l2.autoreload = "0";
	Locations[n].reload.l2.label = "Residence";
	Locations[n].reload.l2.disable = 1;

	Locations[n].reload.l3.name = "reload3";
	Locations[n].reload.l3.go = "Admiral_Office";
	Locations[n].reload.l3.emerge = "reload2";
	Locations[n].reload.l3.autoreload = "0";
	Locations[n].reload.l3.label = "Admiral's Office.";
	Locations[n].reload.l3.disable = 1;

	Locations[n].reload.l4.name = "reload4";
	Locations[n].reload.l4.go = "Governor_Daughter_House";
	Locations[n].reload.l4.emerge = "reload1";
	Locations[n].reload.l4.autoreload = "0";
	Locations[n].reload.l4.label = "Lucia Montavez's House.";
	Locations[n].reload.l4.disable = 1;

	Locations[n].island = "Colombia"; // NK 04-08-29
	n = n + 1;

	if(GetLocationIndex("Tunel")!=-1) return n;
	// -------------------------------------------------
	Locations[n].id = "Tunel";
	Locations[n].filespath.models = "locations\Town_Cartagena\Tunel";
	//Sound
	Locations[n].image = "Town_Cartagena_Tunnel.tga";
	locations[n].type = "military";
	locations[n].id.label = "Fort Tunnel";
	//Models
	//Always
	Locations[n].models.always.locators = "Tunel_l";
	Locations[n].models.always.l1 = "Tunel";
	//Day
	Locations[n].models.day.charactersPatch = "Tunel_p";
	//Night
	Locations[n].models.night.charactersPatch = "Tunel_p";
	//Environment
	Locations[n].environment.weather = "true";
	Locations[n].environment.sea = "false";
	Locations[n].lockWeather = "Alcove";

	//Reload map
	Locations[n].reload.l1.name = "reload27";
	Locations[n].reload.l1.go = "";
	Locations[n].reload.l1.emerge = "";
	Locations[n].reload.l1.autoreload = "0";

	Locations[n].reload.l8.name = "reload26";
	Locations[n].reload.l8.go = "Cartagena_Fort";
	Locations[n].reload.l8.emerge = "reload1";
	Locations[n].reload.l8.autoreload = "1";

	Locations[n].reload.l28.name = "reload26_back";
	Locations[n].reload.l28.go = "Cartagena_Fort";
	Locations[n].reload.l28.emerge = "reload1";
	Locations[n].reload.l28.autoreload = "1";

	Build_at("Tunel", "boxes", "", 0.15658, 0, 11.382, -3.0977, "Building");
	Build_at("Tunel", "Field_Cannon_broken", "", -3.6373, -6.7726, -76.457, 0.0, "Building");
	Build_at("Tunel", "bale", "", -10.02, 0, -3.7811, 1.6198, "Building");
	Build_at("Tunel", "bale", "", -10.02, 0, 6.7764, 1.6198, "Building");
	Build_at("Tunel", "bale", "", 10.087, 0, 6.6039, -1.5344, "Building");
	Build_at("Tunel", "bale", "", 44.509, 0, -16.099, -1.5871, "Building");
	Build_at("Tunel", "bale", "", 40.864, 0, -70.508, 0.0, "Building");
	Build_at("Tunel", "bale", "", 47.101, 0, -66.994, -1.6107, "Building");

	Locations[n].island = "Colombia"; // NK 04-08-29
	n = n + 1;

	if(GetLocationIndex("Admiral_Office")!=-1) return n;
	//-------------------------------------------------
	Locations[n].id = "Admiral_Office";
	locations[n].id.label = "Admiral's Office";
	Locations[n].image = "Town_Havana_Townhall.tga";
	Locations[n].filespath.models = "locations\Inside\Residence2_admiral";
	//Locations[n].filespath.textures = "locations\inside\admiral_office";

	//Town sack
	Locations[n].townsack = "Cartagena";

	//Sound
	locations[n].type = "residence";
	//Models
	//Always
	Locations[n].models.always.city = "Res02";
	Locations[n].models.always.l1 = "bars_down";
//	Locations[n].models.always.l2 = "Adm_lever_down";			//later
//	Locations[n].models.always.l3 = "cannonball";				//later	
//	Locations[n].models.always.l4 = "clockkey";				//later		
	Locations[n].models.always.locators = "Res02_l_BoP1";
	Locations[n].models.always.window = "Res02_w";
	Locations[n].models.always.window.tech = "LocationWindows";
	Locations[n].models.always.window.level = 50;
	//Day
	Locations[n].models.day.charactersPatch = "Res02_p";
	//Night
	Locations[n].models.night.charactersPatch = "Res02_p";
	//Environment
	Locations[n].environment.weather = "false";
	Locations[n].environment.sea = "false";
	Locations[n].models.back = "back\mures2_";
	//Reload map
	Locations[n].reload.l1.name = "reload1";
	Locations[n].reload.l1.go = "Tunel";
	Locations[n].reload.l1.emerge = "reload27";
	Locations[n].reload.l1.autoreload = "0";
	Locations[n].reload.l1.label = "Tunnel.";
	Locations[n].reload.l1.disable = 1;
	Locations[n].locators_radius.reload.reload1 = 0.0001;

	Locations[n].reload.l2.name = "reload2";
	Locations[n].reload.l2.go = "Palace";
	Locations[n].reload.l2.emerge = "reload3";
	Locations[n].reload.l2.autoreload = "0";
	Locations[n].reload.l2.label = "Square Palace.";

	Locations[n].locators_radius.box.box1 = 0.5;
	Locations[n].locators_radius.box.box2 = 0.3;
	Locations[n].locators_radius.box.box3 = 0.6;
	Locations[n].locators_radius.box.box4 = 0.9;
	Locations[n].locators_radius.box.box5 = 0.8;

	Locations[n].locators_radius.randitem.randitem1 = 0.01;
	Locations[n].items.randitem1 = "steplock2";

	Locations[n].locators_radius.randitem.randitem2 = 0.01;
	Locations[n].items.randitem2 = "steplock_v";

	Locations[n].locators_radius.randitem.randitem3 = 0.01;
	Locations[n].items.randitem3 = "build_clock2";

	Locations[n].locators_radius.randitem.randitem4 = 0.8;
	Locations[n].items.randitem4 = "cannonball2";			//on floor

	Locations[n].island = "Colombia"; // NK 04-08-29
	n = n + 1;

	if(GetLocationIndex("Palace_Residence")!=-1) return n;
	//  -------------------------------------------------
	Locations[n].id = "Palace_Residence";
	locations[n].id.label = "Residence";
	//Town sack
	Locations[n].townsack = "Cartagena";
	//Sound
	locations[n].type = "residence";

	InitResidence7(Locations[n].id);

    	Locations[n].models.always.locators = "res07_locators_BoP";

	//Reload map
	Locations[n].reload.l1.go = "Palace";
	Locations[n].reload.l1.emerge = "reload2";
	Locations[n].reload.l1.label = "Square Palace";

	Locations[n].locators_radius.randitem.randitem1 = 0.01;
	Locations[n].items.randitem1 = "lever_item";

	Locations[n].locators_radius.randitem.randitem2 = 0.8;
	Locations[n].items.randitem2 = "pillow";

	Locations[n].island = "Colombia";
	n = n + 1;

	if(GetLocationIndex("Governor_Daughter_House")!=-1) return n;
	// -------------------------------------------------
//	Locations[n].filespath.models = "locations\Inside\Residence3";
	Locations[n].filespath.models = "locations\Inside\Residence3_red";

	Locations[n].id = "Governor_Daughter_House";
	locations[n].id.label = "House";
	Locations[n].image = "Inside_Residence3.tga";

	//Town sack
	Locations[n].townsack = "Cartagena";

	//Sound
	locations[n].type = "Residence";
	//Models
	//Always
	Locations[n].models.always.locators = "Res03_l_BoP1";
	Locations[n].models.always.l1 = "Res03";
	Locations[n].models.always.window = "Res03_w";
	Locations[n].models.always.window.tech = "LocationWindows";
	Locations[n].models.always.window.level = 50;
	//Day
	Locations[n].models.day.charactersPatch = "Res03_p";

	//Night
	Locations[n].models.night.charactersPatch = "Res03_p";

	//Environment
	Locations[n].environment.weather = "false";
	Locations[n].environment.sea = "false";
	//Locations[n].models.back = "back\mures3_";
	Locations[n].models.back = "back\redrsb_";
	//Reload map
	Locations[n].reload.l1.name = "reload1";
	Locations[n].reload.l1.go = "Palace";
	Locations[n].reload.l1.emerge = "reload4";
	Locations[n].reload.l1.autoreload = "0";
	Locations[n].reload.l1.label = "Square Palace.";

	Locations[n].reload.l2.name = "reload2";
	Locations[n].reload.l2.go = "Woman_Palace_bedroom";
	Locations[n].reload.l2.emerge = "reload1";
	Locations[n].reload.l2.autoreload = "0";
	Locations[n].reload.l2.label = "Bedroom.";

	Locations[n].locators_radius.randitem.randitem1 = 0.01;
	Locations[n].items.randitem1 = "clockkey";

	Locations[n].locators_radius.randitem.randitem2 = 0.7;
	Locations[n].items.randitem2 = "clockkey";

	Locations[n].island = "Colombia";
	n = n + 1;

	if(GetLocationIndex("Woman_Palace_bedroom")!=-1) return n;
	// -------------------------------------------------
	locations[n].id = "Woman_Palace_bedroom";
	locations[n].id.label = "Bedroom";
	Locations[n].filespath.models = "locations\inside\ResBedRoom";
	Locations[n].filespath.textures = "locations\inside\wr_bedroom";
	Locations[n].image = "Inside_ResBedRoom.tga";
	//Town sack
	Locations[n].townsack = "Cartagena";
	//Sound
	locations[n].type = "Residence";
	//Models
	//Always
	Locations[n].models.always.locators = "bed_l_BoP";
	Locations[n].models.always.l1 = "bed";
	Locations[n].models.always.window = "bed_w";
	Locations[n].models.always.window.tech = "LocationWindows";
	Locations[n].models.always.window.level = 50;
	//Day
	Locations[n].models.day.charactersPatch = "bed_p";
	//Night
	Locations[n].models.night.charactersPatch = "bed_p";	
	//Environment
	Locations[n].environment.weather = "false";
	Locations[n].environment.sea = "false";
	Locations[n].models.back = "back\redb_";
	//Reload map
	locations[n].reload.l1.name = "reload1";
	locations[n].reload.l1.go = "Governor_Daughter_House";
	locations[n].reload.l1.emerge = "reload2";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "House";

	Locations[n].locators_radius.randitem.randitem1 = 1.2;
	Locations[n].items.randitem1 = "fire_irons_item";

	Locations[n].island = "Colombia";
	n = n + 1;

	if(GetLocationIndex("Cartagena_Townhall")!=-1) return n;
 	//-------------------------------------------------
	Locations[n].id = "Cartagena_Townhall";
	locations[n].id.label = "Townhall";
	Locations[n].filespath.models = "locations\inside\Residence_BackHall";
	Locations[n].image = "Inside_Residence_BackHall.tga";

	//Town sack
	Locations[n].townsack = "Cartagena";
	//Sound
	locations[n].type = "residence";
	//Models
	//Always
	Locations[n].models.always.locators = "ResB_l";
	Locations[n].models.always.l1 = "ResB";
	Locations[n].models.always.window = "ResB_w";
	Locations[n].models.always.window.tech = "LocationWindows";
	Locations[n].models.always.window.level = 50;
	//Day
	Locations[n].models.day.charactersPatch = "ResB_p";
	Locations[n].models.day.lights.candles = "candelabrum_small";

	//Night
	Locations[n].models.night.charactersPatch = "ResB_p";
	Locations[n].models.night.lights.candles = "candelabrum_small";

	//Environment
	Locations[n].environment.weather = "false";
	Locations[n].environment.sea = "false";
	Locations[n].models.back = "back\redrsb_";
	//Reload map
	Locations[n].reload.l1.name = "reload1";
	Locations[n].reload.l1.go = "Residence_Cartagena";
	Locations[n].reload.l1.emerge = "reload3_back";
	Locations[n].reload.l1.autoreload = "0";
	Locations[n].reload.l1.label = "Townhall's Garden.";
	LAi_LocationFightDisable(&Locations[n], true);

	Locations[n].island = "Colombia"; // NK 04-08-29
	n = n + 1;

	if(GetLocationIndex("Cartagena_Center")!=-1) return n;	
 	//-------------------------------------------------
	Locations[n].filespath.models = "locations\Town_Cartagena\town";
	Locations[n].filespath.textures = "locations\vco";
	Locations[n].image = "Town_Cartagena_Town.tga";

	Locations[n].id = "Cartagena_Center";
	locations[n].id.label = "Cartagena town.";
	locations[n].worldmap = "Colombia";

	//Town sack
	Locations[n].townsack = "Cartagena";
	//Sound
	locations[n].type = "town";
	LAi_LocationFantomsGen(&locations[n], true);	
	//Models
	//Always
	Locations[n].models.always.locators = "locator";
	Locations[n].models.always.town = "1007001";
	Locations[n].models.always.grassPatch = "gr1007001";
	Locations[n].models.always.tree = "tree";
	Locations[n].models.always.tree.locator.group = "locator";
	Locations[n].models.always.tree.locator.name = "001";	
	//Day
	Locations[n].models.day.charactersPatch = "walk_patch";
	//Night
	Locations[n].models.night.charactersPatch = "walk_patch";
	//Environment
	Locations[n].environment.weather = "true";
	Locations[n].environment.sea = "false";
	//Reload map
	Locations[n].reload.l1.name = "reload1";
	Locations[n].reload.l1.go = "Cartagena_town_01";
	Locations[n].reload.l1.emerge = "Reload_2_4";
	Locations[n].reload.l1.autoreload = "0";
	Locations[n].reload.l1.label = "Cartagena town.";
	Locations[n].locators_radius.reload.reload1 = 2.0;	

	Locations[n].island = "Colombia"; // NK 04-08-29	
	n = n + 1;	

	return n;
}
	// -------------------------------------------------

void ColombiaWorldMapInit()
{
	if(CheckAttribute(worldMap.islands,"Colombia")) return;

	Islands[FindIsland("Colombia")].reload_enable = true; // CTM
	Islands[FindIsland("Colombia")].visible = true; // CTM

	//Name
	worldMap.islands.Colombia.name = "Colombia";
	//Geometry parameters
	worldMap.islands.Colombia.position.x = 785.0;  // East  = +, West  = -
	worldMap.islands.Colombia.position.y = 30.0;
	worldMap.islands.Colombia.position.z = 390.0;   // North = -, South = +
	worldMap.islands.Colombia.position.rx = 760.0;
	worldMap.islands.Colombia.position.rz = 400.0;
	worldMap.islands.Colombia.radius = 40.0;
	worldMap.islands.Colombia.kradius = 0.75;

	//Island label
	worldMap.islands.Colombia.old.label.text = "Colombia";
	worldMap.islands.Colombia.label.text = TranslateString("","Colombia");
	worldMap.islands.Colombia.label.icon = -1;
	worldMap.islands.Colombia.label.visible = "true";

	//Cities - way for adding new fake island-model into the WorldMap
	//Geometry parameters
	worldMap.islands.Colombia.locations.city0.position.x = worldMap.islands.Colombia.position.x;
	worldMap.islands.Colombia.locations.city0.position.y = 0.0;
	worldMap.islands.Colombia.locations.city0.position.z = worldMap.islands.Colombia.position.z + 15.0;
	worldMap.islands.Colombia.locations.city0.position.ay = 0.0;
	worldMap.islands.Colombia.locations.city0.modelName = "leaf";
	worldMap.islands.Colombia.locations.city0.visible = "true";
	worldMap.islands.Colombia.locations.city0.move = "false";
}

void DeleteColombia()
{
	if(FindIsland("Colombia")!=-1)
	{
		Islands[FindIsland("Colombia")].reload_enable = false;
		Islands[FindIsland("Colombia")].visible = false;
		aref ourMap; makearef(ourMap,worldMap.islands);
		DeleteAttribute(ourMap,"Colombia");
		if(wdmCurrentIsland=="Colombia") wdmCurrentIsland = WDM_NONE_ISLAND;
	}
}
// ----------------
// PB FUNCTIONS <--
// ----------------